require "import"
import "android.content.Context"
import "android.content.Intent"
import "android.graphics.Color"
import "android.media.AudioDeviceInfo"
import "android.media.AudioManager"
import "android.media.MediaExtractor"
import "android.media.MediaFormat"
import "android.media.MediaMetadataRetriever"
import "android.media.MediaPlayer"
import "android.media.MediaRecorder"
import "android.view.View"
import "android.media.ToneGenerator"
import "android.net.Uri"
import "android.os.Environment"
import "android.os.Handler"
import "android.os.Looper"
import "android.os.PowerManager"
import "android.os.StrictMode"
import "android.preference.*"
import "android.text.*"
import "android.util.SparseBooleanArray"
import "android.widget.*"
import "android.widget.AbsListView"
import "android.widget.AdapterView"
import "android.widget.ArrayAdapter"
import "android.widget.Button"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.ListView"
import "android.widget.PopupMenu"
import "android.widget.SeekBar"
import "android.widget.TextView"
import "android.widget.Toast"
import "com.androlua.LuaDialog"
import "java.io.File"
import "java.lang.Runnable"
import "java.text.SimpleDateFormat"
import "java.util.ArrayList"
import "java.util.Date"
import "luajava"
import "android.app.Activity"



local prefs = service.getSharedPreferences("audio_recordings_pro", 0)
local prefsEditor = prefs.edit()
sortMode = prefs.getString("sortMode", "alphabetical_az")
currentAudioEncodingBitRate = tonumber(prefs.getString("audio_encoding_bitrate", "128000"))
currentAudioSamplingRate = tonumber(prefs.getString("audio_sampling_rate", "44100"))
currentAudioSource = tonumber(prefs.getString("audio_source", tostring(MediaRecorder.AudioSource.MIC)))
currentAudioChannels = tonumber(prefs.getString("audio_channels", "2"))


vadEnabled    = prefs.getString("vad_enabled",    "false") == "true"  -- تشغيل/إيقاف
vadThreshold  = tonumber(prefs.getString("vad_threshold",  "200"))    -- شِدّة الصوت
vadSilenceMs  = tonumber(prefs.getString("vad_silence_ms", "3000"))   -- مدة السكون بالملّي ثانية

currentFilePath = prefs.getString("my_audio_folder", "/storage/emulated/0/Documents/Audio recorder pro")
mainFunctionName = prefs.getString("main_function", "toggleRecording")
discardFunctionName = prefs.getString("discard_function", "nullFunc")
stopFunctionName = prefs.getString("stop_function", "nullFunc")
cancelFunctionName = prefs.getString("cancel_function", "recordingOptions")
savedRepeatMode = tonumber(prefs.getString("repeat_mode", "0"))
savedSeekSeconds = tonumber(prefs.getString("seek_seconds", "10000"))
keepSpeedPitch = prefs.getString("keep_speed_pitch", "true") == "true"
lastPlayingFile = prefs.getString("current_playing_file", nil)
lastPosition = prefs.getInt("last_position", 0)


mp = nil
currentFile = nil
isCompleted = false
isRepeatModeOn = false
repeatMode = savedRepeatMode or 0
currentIndex = 1
savedSpeed = 1.0
savedPitch = 1.0
mainHandler = Handler(Looper.getMainLooper())
updateSeekBarRunnable = nil

_vadHandler  = _vadHandler  or Handler(Looper.getMainLooper())
_vadRunnable = _vadRunnable or nil

_G.pendingSchedules = _G.pendingSchedules or {}
_G.scheduleIdCounter = _G.scheduleIdCounter or 0


_G.autoStopTask = nil
_G.autoStopRemaining = nil

_G.activeTaskRunning = _G.activeTaskRunning or false

_G.updateRemainingRunnable = nil


_G.isTimerRunning = _G.isTimerRunning or false
_G.isTimerPaused = _G.isTimerPaused or false
_G.elapsedSeconds = _G.elapsedSeconds or 0
_G.timerHandler = _G.timerHandler or Handler(Looper.getMainLooper())
_G.timerRunnable = _G.timerRunnable or nil


function formatCountdown(sec)
  if not sec or sec < 0 then sec = 0 end

  local h = math.floor(sec / 3600)
  local m = math.floor((sec % 3600) / 60)
  local s = sec % 60
  return string.format("%02d:%02d:%02d", h, m, s)
end


function resetRemainingTime()
  if _G.updateRemainingRunnable and mainHandler then
    mainHandler.removeCallbacks(_G.updateRemainingRunnable)
    _G.updateRemainingRunnable = nil
  end
  if _G.remainingTime then
    _G.remainingTime.setText("Remaining: --:--")
  end
  _G.autoStopRemaining = nil
  _G.autoStopEndAt     = nil
end


function toggleTimer()
  local function formatTime()
    local hours = math.floor(_G.elapsedSeconds / 3600)
    local minutes = math.floor((_G.elapsedSeconds % 3600) / 60)
    local seconds = _G.elapsedSeconds % 60
    return string.format("%02d:%02d:%02d", hours, minutes, seconds)
  end
  if not _G.isTimerRunning then
    _G.isTimerRunning = true
    _G.isTimerPaused = false
    _G.elapsedSeconds = 0
    _G.timerRunnable = luajava.createProxy("java.lang.Runnable", {
      run = function()
        if not _G.isTimerPaused then
          _G.elapsedSeconds = _G.elapsedSeconds + 1
          local timeText = formatTime()
        end
        _G.timerHandler.postDelayed(_G.timerRunnable, 1000)
      end
    })
    _G.timerHandler.post(_G.timerRunnable)
   elseif _G.isTimerRunning and not _G.isTimerPaused then
    _G.isTimerPaused = true
   elseif _G.isTimerRunning and _G.isTimerPaused then
    _G.isTimerPaused = false
  end
end



function stopTimer()
  if _G.timerHandler and _G.timerRunnable then
    _G.timerHandler.removeCallbacks(_G.timerRunnable)
  end
  _G.isTimerRunning = false
  _G.isTimerPaused = false
  _G.elapsedSeconds = 0
  _G.timerRunnable = nil
end



function nullFunc()
end


function changeFolderPath()
  local dialog = LuaDialog(this)
  dialog.setTitle("Change Recordings Folder Path")
  local json = require("cjson")
  local savedPathsJson = prefs.getString("saved_paths", "[]")
  local savedPaths = json.decode(savedPathsJson)
  local dialogLayout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    padding = "16dp",
    {
      TextView,
      layout_width = "match_parent",
      layout_height = "wrap_content",
      text = "Current Path: "..currentFilePath,
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = "#FF0000",
      layout_marginBottom = "10dp",
    },
    {
      ListView,
      tag = "pathsListView",
      layout_width = "match_parent",
      layout_height = "200dp",
      dividerHeight = "1dp",
      backgroundColor = "0xFF000000",
    }
  }
  local view = loadlayout(dialogLayout)
  local newPathInput = view.findViewWithTag("newPathInput")
  local pathsListView = view.findViewWithTag("pathsListView")
  local ArrayAdapter = luajava.bindClass("android.widget.ArrayAdapter")
  local context = activity or this
  local adapter = ArrayAdapter(context, android.R.layout.simple_list_item_1, savedPaths)
  pathsListView.setAdapter(adapter)
  pathsListView.setOnItemClickListener(AdapterView.OnItemClickListener{
    onItemClick = function(_, _, position, _)
      local selectedPath = savedPaths[position + 1]
      local file = File(selectedPath)
      if not file.exists() then
        local success = file.mkdirs()
        if not success then
          service.postSpeak(400, "Failed to create folder. Please check permissions or path.")
          return
        end
      end
      if file.exists() and file.isDirectory() then
        prefs.edit().putString("my_audio_folder", selectedPath).apply()
        currentFilePath = selectedPath
        audioRecorderPro()
        service.postSpeak(200, "Path activated successfully.")
        dialog.dismiss()
       else
        service.postSpeak(400, "Invalid path or not a directory.")
      end
    end
  })
  pathsListView.setOnItemLongClickListener(AdapterView.OnItemLongClickListener{
    onItemLongClick = function(_, _, position, _)
      local selectedPath = savedPaths[position + 1]
      local confirmDialog = LuaDialog(this)
      confirmDialog.setTitle("Confirm Deletion")
      confirmDialog.setMessage("Do you want to delete this path?\n" .. selectedPath)
      confirmDialog.setButton("Delete", function()
        table.remove(savedPaths, position + 1)
        prefs.edit().putString("saved_paths", json.encode(savedPaths)).apply()
        adapter = ArrayAdapter(context, android.R.layout.simple_list_item_1, savedPaths)
        pathsListView.setAdapter(adapter)
        service.postSpeak(200, "Path deleted successfully.")
        confirmDialog.dismiss()
      end)
      confirmDialog.setButton2("Cancel", function()
        confirmDialog.dismiss()
      end)
      confirmDialog.show()
      return true
    end
  })
  dialog.setView(view)
  dialog.show()
end




function manageFolderPath()
  local dialog = LuaDialog(this)
  dialog.setTitle("Change Recordings Folder Path")
  local json = require("cjson")
  local savedPathsJson = prefs.getString("saved_paths", "[]")
  local savedPaths = json.decode(savedPathsJson)

  local dialogLayout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    padding = "16dp",
    {
      TextView,
      layout_width = "match_parent",
      layout_height = "wrap_content",
      text = "Current Path:",
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = "#000000",
      layout_marginBottom = "10dp",
    },
    {
      TextView,
      layout_width = "match_parent",
      layout_height = "wrap_content",
      text = currentFilePath,
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = "#FF0000",
      layout_marginBottom = "10dp",
    },
    {
      EditText,
      tag = "newPathInput",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      hint = "Enter new path here",
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = "#0000FF",
      singleLine = true,
      layout_marginBottom = "10dp",
    },
    {
      ListView,
      tag = "pathsListView",
      layout_width = "match_parent",
      layout_height = "200dp",
      dividerHeight = "1dp",
    }
  }

  local view = loadlayout(dialogLayout)
  local newPathInput = view.findViewWithTag("newPathInput")
  local pathsListView = view.findViewWithTag("pathsListView")

  local context = activity or this
  local ArrayAdapter = luajava.bindClass("android.widget.ArrayAdapter")
  local adapter = ArrayAdapter(context, android.R.layout.simple_list_item_1, savedPaths)
  pathsListView.setAdapter(adapter)


  pathsListView.setOnItemClickListener(AdapterView.OnItemClickListener{
    onItemClick = function(_, _, position, _)
      local selectedPath = savedPaths[position + 1]
      local file = File(selectedPath)
      if not file.exists() then
        local success = file.mkdirs()
        if not success then
          service.postSpeak(400, "Failed to create folder. Please check permissions or path.")
          return
        end
      end
      if file.exists() and file.isDirectory() then
        prefs.edit().putString("my_audio_folder", selectedPath).apply()
        currentFilePath = selectedPath
        audioRecorderPro()
        service.postSpeak(200, "Path activated successfully.")
        dialog.dismiss()
       else
        service.postSpeak(400, "Invalid path or not a directory.")
      end
    end
  })

  pathsListView.setOnItemLongClickListener(AdapterView.OnItemLongClickListener{
    onItemLongClick = function(_, _, position, _)
      local selectedPath = savedPaths[position + 1]
      local confirmDialog = LuaDialog(this)
      confirmDialog.setTitle("Confirm Deletion")
      confirmDialog.setMessage("Do you want to delete this path?\n" .. selectedPath)
      confirmDialog.setButton("Delete", function()
        table.remove(savedPaths, position + 1)
        prefs.edit().putString("saved_paths", json.encode(savedPaths)).apply()
        adapter = ArrayAdapter(context, android.R.layout.simple_list_item_1, savedPaths)
        pathsListView.setAdapter(adapter)
        service.postSpeak(200, "Path deleted successfully.")
        confirmDialog.dismiss()
      end)
      confirmDialog.setButton2("Cancel", function()
        confirmDialog.dismiss()
      end)
      confirmDialog.show()
      return true
    end
  })

  dialog.setView(view)
  dialog.setButton("Save", function()
    local newPath = tostring(newPathInput.getText())
    if newPath and newPath ~= "" then
      local file = File(newPath)
      if not file.exists() then
        local success = file.mkdirs()
        if not success then
          service.postSpeak(400, "Failed to create folder. Please check permissions or path.")
          return
        end
      end
      if file.exists() and file.isDirectory() then
        prefs.edit().putString("my_audio_folder", newPath).apply()
        currentFilePath = newPath
        audioRecorderPro()
        service.postSpeak(200, "New path saved successfully!")
        local found = false
        for _, v in ipairs(savedPaths) do
          if v == newPath then
            found = true
            break
          end
        end
        if not found then
          table.insert(savedPaths, newPath)
          prefs.edit().putString("saved_paths", json.encode(savedPaths)).apply()
        end
       else
        service.postSpeak(400, "Invalid path entered or it does not point to a folder.")
      end
     else
      service.postSpeak(400, "Please enter a valid path.")
    end
  end)

  dialog.setButton2("Cancel", nil)
  dialog.setButton3("Clear All", function()
    local confirmDialog = LuaDialog(this)
    confirmDialog.setTitle("Confirm Deletion")
    confirmDialog.setMessage("Are you sure you want to delete all saved paths?")
    confirmDialog.setButton("Yes", function()
      prefs.edit().remove("saved_paths").apply()
      service.postSpeak(200, "All paths have been deleted.")
      confirmDialog.dismiss()
      dialog.dismiss()
    end)
    confirmDialog.setButton2("No", function()
      confirmDialog.dismiss()
    end)
    confirmDialog.show()
  end)

  dialog.show()
end




function scheduleRecording()
  local dialog = LuaDialog(this)
  dialog.setTitle("Schedule Recording")
  local dialogLayout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    padding = "16dp",
    backgroundColor = "#000000",
    {
      EditText,
      id = "recTime",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      hint = "Enter time (HH:MM)",
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = 0xFF0D47A1,
      inputType = "number",
      singleLine = true
    },
    {
      EditText,
      id = "recDur",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      hint = "Optional duration (HH:MM)",
      textSize = "16sp",
      textColor = "#FFFFFF",
      backgroundColor = 0xFF0D47A1,
      inputType = "number",
      singleLine = true
    }
  }
  local view = loadlayout(dialogLayout)
  dialog.setView(view)

  local function addAutoFormatting(et, nextEt)
    local last = ""
    et.addTextChangedListener(TextWatcher {
      afterTextChanged = function(s)
        local t = tostring(s)
        if t == last then return end
        local c = t:gsub("[^%d]", "")
        local f = (#c > 2) and (c:sub(1,2) .. ":" .. c:sub(3,4)) or c
        last = f
        et.setText(f)
        et.setSelection(#f)
        if nextEt and #f == 5 and f:match("^%d%d:%d%d$") then
          nextEt.requestFocus()
        end
      end
    })
  end
  addAutoFormatting(recTime, recDur)
  addAutoFormatting(recDur)

  dialog.setButton("OK", function()
    local recTimeStr = recTime.getText().toString():match("^%s*(.-)%s*$")
    local recDurStr  = recDur.getText().toString():match("^%s*(.-)%s*$")
    if recTimeStr == "" then
      Toast.makeText(this, "Please enter a valid time in the format HH:MM", 0).show()
      return
    end
    local h, m = recTimeStr:match("^(%d+):(%d+)$")
    h, m = tonumber(h), tonumber(m)
    if not h or not m or h > 23 or m > 59 then
      Toast.makeText(this, "Invalid time. Please enter a valid time in HH:MM format.", 0).show()
      return
    end
    local now = os.date("*t")
    local tgt = os.time{year = now.year, month = now.month, day = now.day, hour = h, min = m, sec = 0}
    if tgt <= os.time() then tgt = tgt + 86400 end
    local delayMillis = (tgt - os.time()) * 1000
    local function parseTime(str)
      local hh, mm = str:match("(%d+):(%d+)")
      return tonumber(hh or 0) * 60 + tonumber(mm or 0)
    end
    local handler = Handler(Looper.getMainLooper())
    local runnable
    local runnableStop

    runnableStop = luajava.createProxy("java.lang.Runnable", {
      run = function()
        toggleRecordingPreset()
      end
    })

    runnable = luajava.createProxy("java.lang.Runnable", {
      run = function()
        for i, itm in ipairs(_G.pendingSchedules) do
          if itm.job == runnable then
            table.remove(_G.pendingSchedules, i)
            break
          end
        end
        toggleRecordingPreset()
        if recDurStr ~= "" then
          local durMillis = parseTime(recDurStr) * 60 * 1000
          handler.postDelayed(runnableStop, durMillis)
        end
      end
    })

    handler.postDelayed(runnable, delayMillis)

    _G.scheduleIdCounter = _G.scheduleIdCounter + 1
    table.insert(_G.pendingSchedules, {
      id      = _G.scheduleIdCounter,
      label   = os.date("%H:%M", tgt),
      handler = handler,
      job     = runnable,
      stopper = runnableStop
    })
    service.postSpeak(400, "Task scheduled")
    service.postClick(200, {{"%Retour"}})
  end)

  dialog.setButton2("Cancel", nil)
  dialog.show()
end



function startRecordingWithAutoStop(anchor)
anchor = anchor or presetRecording   
  if _G.autoStopTask then
    pcall(function() _G.autoStopTask.stop() end)
    _G.autoStopTask = nil
  end
local popup = PopupMenu(this, anchor)
local menu = popup.getMenu()

        local items = {
          "00:05", "00:10", "00:15", "00:20", "00:30",
          "00:45", "01:00", "01:15", "01:30", "01:45", "02:00"
        }

        for _, item in ipairs(items) do
          menu.add(item)
        end

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())
if title == "00:05" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 306000
    _G.autoStopTask  = task(306000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "00:10" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 606000
    _G.autoStopTask  = task(606000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "00:15" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 906000
    _G.autoStopTask  = task(906000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "00:20" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 1206000
    _G.autoStopTask  = task(1206000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "00:30" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 1806000
    _G.autoStopTask  = task(1806000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "00:45" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 2706000
    _G.autoStopTask  = task(2706000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "01:00" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 3606000
    _G.autoStopTask  = task(3606000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "01:15" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 4506000
    _G.autoStopTask  = task(4506000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "01:30" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 5406000
    _G.autoStopTask  = task(5406000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "01:45" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 6306000
    _G.autoStopTask  = task(6306000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

elseif title == "02:00" then
  if isCurrentlyRecording() then
    toggleRecordingPreset()
  else
    _G.autoStopEndAt = os.time()*1000 + 7206000
    _G.autoStopTask  = task(7206000, function()
      if isCurrentlyRecording() then
        toggleRecordingPreset()
      end
    end)
    toggleRecordingPreset()
  end

else
  print("毓賳氐乇 睾賷乇 賲毓乇賵賮: " .. title)
end

            return true
          end
        })

        popup.show()
end


function isCurrentlyRecording()
  return _G.isRecording == true and _G.hasStartedRecording == true and _G.isPaused == false
end
















function manageRecordings()
  local path = currentFilePath
  local fullFileList = io.ls(path)
  local menuItems = {}
  local fileMap = {}
  local currentlyDisplayedItems = {}

  local selectedPositions = SparseBooleanArray()
  for _, filename in ipairs(fullFileList) do
    local nameOnly = filename:match("(.+)%..+$") or filename
    table.insert(menuItems, nameOnly)
    fileMap[nameOnly] = filename
  end

  currentlyDisplayedItems = {}
  for _, item in ipairs(menuItems) do
    table.insert(currentlyDisplayedItems, item)
  end

  dlg = LuaDialog(this)
  local toolsView = {
    LinearLayout,
    orientation = 1,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    {
      TextView,
      id = "textview_button",
      text = "Manage Recordings (" .. #menuItems .. ")",
      onClick=function(v)
        local fileCount = #fullFileList
        local totalSize = 0
        for _, filename in ipairs(fullFileList) do
          local file = File(path .. "/" .. filename)
          if file.exists() and file.isFile() then
            totalSize = totalSize + file.length()
          end
        end
        local sizeText
        if totalSize < 1024 then
          sizeText = totalSize .. " B"
         elseif totalSize < 1024 * 1024 then
          sizeText = string.format("%.2f KB", totalSize / 1024)
         else
          sizeText = string.format("%.2f MB", totalSize / (1024 * 1024))
        end
        print("Number of files: " .. fileCount)
        print("Total size: " .. sizeText)
      end,
      onLongClickListener = {
        onLongClick = function(v)
          manageFolderPath()
          dlg.dismiss()
          return true
        end
      },
      layout_width = "match_parent",
      layout_height = "wrap_content",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      textSize = "30sp",
      gravity = "center",
    },
    {
      EditText,
      id = "searchInput",
      hint = "Search by letters or numbers.",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      backgroundColor = 0xFF0D47A1,
      padding = "8dp",
      textSize = "18sp",
    },
    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      {
        TextView,
        id = "selectAllButton",
        text = "Select All",
        layout_width = "0dp",
        layout_weight = 0.33,
        layout_height = "match_parent",
        padding = "8dp",
        textSize = "18sp",
        textColor = "#FFFFFF",
        backgroundColor = "0xFF222222",
        gravity = "center",
        onClick = function(v)
          local allSelected = true
          for i = 0, menuList.getCount() - 1 do
            if not menuList.isItemChecked(i) then
              allSelected = false
              break
            end
          end

          selectedPositions.clear()
          for i = 0, menuList.getCount() - 1 do
            menuList.setItemChecked(i, not allSelected)
            if not allSelected then
              selectedPositions.put(i, true)
            end
          end

          local count = selectedPositions.size()
          if count > 0 then
            textview_button.setText("Manage Recordings (" .. count .. " selected)")
           else
            textview_button.setText("Manage Recordings (" .. #currentlyDisplayedItems .. ")")
          end
          if not allSelected then
            selectAllButton.setBackgroundColor(0xFF2E7D32)
            selectAllButton.setText("Unselect All")
           else
            selectAllButton.setBackgroundColor(0xFF000000)
            selectAllButton.setText("Select All")
          end

          local speakText = not allSelected
          and ("All displayed items selected: " .. count)
          or "Selection cleared."
          Toast.makeText(this, speakText, 0).show()
          service.postSpeak(400, speakText)
        end
      },
      {
        TextView,
        id = "invertSelectionButton",
        text = "Invert Selection",
        layout_width = "0dp",
        layout_weight = 0.33,
        layout_height = "match_parent",
        padding = "8dp",
        textSize = "18sp",
        textColor = "#FFFFFF",
        backgroundColor = "0xFF303F9F", 
        gravity = "center",
        onClick = function(v)
          for i = 0, menuList.getCount() - 1 do
            local wasChecked = menuList.isItemChecked(i)
            menuList.setItemChecked(i, not wasChecked)
            if wasChecked then
              selectedPositions.delete(i)
             else
              selectedPositions.put(i, true)
            end
          end
          local count = selectedPositions.size()
          if count > 0 then
            textview_button.setText("Manage Recordings (" .. count .. " selected)")
            service.postSpeak(300, "Selected " .. count .. " items")
           else
            textview_button.setText("Manage Recordings (" .. #currentlyDisplayedItems .. ")")
            service.postSpeak(300, "Selection empty")
          end

          if count == menuList.getCount() then
            selectAllButton.setBackgroundColor(0xFF2E7D32)
            selectAllButton.setText("Unselect All")
           else
            selectAllButton.setBackgroundColor(0xFF000000)
            selectAllButton.setText("Select All")
          end
        end
      },
      {
        TextView,
        id = "actionsButton",
        text = "Actions",
        onClick = function(v)
          local popup = PopupMenu(this, v)
          local menu = popup.getMenu()
          menu.add("Delete")
          menu.add("Share")
          menu.add("Share via Telegram")
          menu.add("Share via WhatsApp")
          menu.add("Share via Messenger")
          menu.add("Share via Drive")

          popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
            onMenuItemClick = function(item)
              local title = tostring(item.getTitle())

              if title == "Delete" then
                if selectedPositions.size() > 0 then
                  local confirmDeleteDialog = LuaDialog(this)
                  confirmDeleteDialog.setTitle("Confirm Deletion")
                  confirmDeleteDialog.setMessage(
                  "Are you sure you want to delete " ..
                  selectedPositions.size() .. " item(s)?")
                  confirmDeleteDialog.setButton("Yes", function()
                    local filesToDelete = {}
                    local itemsToRemoveFromCurrentlyDisplayed = {}
                    local originalPositionsToRemove = SparseBooleanArray()
                    for i = 0, selectedPositions.size() - 1 do
                      local posInDisplayedList = selectedPositions.keyAt(i)
                      local displayName = adapter.getItem(posInDisplayedList)
                      local actualFile = fileMap[displayName]
                      table.insert(filesToDelete, actualFile)
                      table.insert(itemsToRemoveFromCurrentlyDisplayed, displayName)
                      originalPositionsToRemove.put(posInDisplayedList, true)
                    end
                    for _, filename in ipairs(filesToDelete) do
                      local fullPath = filename:match("^/") and filename
                      or path .. "/" .. filename
                      local file = File(fullPath)
                      if file.exists() then
                        file.delete()
                      end
                    end
                    menuItems = {}
                    fileMap = {}
                    local updatedFullFileList = io.ls(path)
                    for _, filename in ipairs(updatedFullFileList) do
                      local nameOnly = filename:match("(.+)%..+$") or filename
                      table.insert(menuItems, nameOnly)
                      fileMap[nameOnly] = filename
                    end
                    local currentQuery = tostring(searchInput.getText()):lower()
                    if currentQuery ~= "" then
                      currentlyDisplayedItems = {}
                      for _, item in ipairs(menuItems) do
                        if item:lower():find(currentQuery, 1, true) then
                          table.insert(currentlyDisplayedItems, item)
                        end
                      end
                     else
                      currentlyDisplayedItems = {}
                      for _, item in ipairs(menuItems) do
                        table.insert(currentlyDisplayedItems, item)
                      end
                    end
                    adapter = ArrayAdapter(this,
                    android.R.layout.simple_list_item_multiple_choice,
                    currentlyDisplayedItems)
                    menuList.setAdapter(adapter)
                    selectedPositions.clear()
                    for i = 0, menuList.getCount() - 1 do
                      menuList.setItemChecked(i, false)
                    end
                    textview_button.setText(
                    "Manage Recordings (" .. #currentlyDisplayedItems .. ")")
                    Toast.makeText(this, "Selected items deleted.", 0).show()
                    service.postSpeak(600, "Selected items deleted.")
service.postClick(1700,{{"%Effacer le texte"}})
                    selectAllButton.setBackgroundColor(0xFF000000)
                    selectAllButton.setText("Select All")
                  end)
                  confirmDeleteDialog.setButton2("No", nil)
                  confirmDeleteDialog.show()
                 else
                  Toast.makeText(this, "No item selected.", 0).show()
                end

               elseif title == "Share"
                or title == "Share via Telegram"
                or title == "Share via WhatsApp"
                or title == "Share via Messenger"
                or title == "Share via Drive" then
                dlg.dismiss()
                stopAll()

                local packageMap = {
                  ["Share via Telegram"] = "org.telegram.messenger",
                  ["Share via WhatsApp"] = "com.whatsapp",
                  ["Share via Messenger"] = "com.facebook.orca",
                  ["Share via Drive"] = "com.google.android.apps.docs",
                }

                local filesToShare = {}

                if selectedPositions.size() > 0 then
                  for i = 0, selectedPositions.size() - 1 do
                    local pos = selectedPositions.keyAt(i)
                    local displayName = adapter.getItem(pos)
                    local actualFile = fileMap[displayName]
                    local fullPath = path .. "/" .. actualFile
                    local file = File(fullPath)
                    if file.exists() then
                      local uri = service.getUriForFile(file)
                      table.insert(filesToShare, uri)
                    end
                  end
                 elseif selectedItemText then
                  local actualFile = fileMap[selectedItemText]
                  local fullPath = path .. "/" .. actualFile
                  local file = File(fullPath)
                  if file.exists() then
                    local uri = service.getUriForFile(file)
                    table.insert(filesToShare, uri)
                  end
                end

                if #filesToShare > 0 then
                  local shareIntent = Intent()
                  if #filesToShare == 1 then
                    shareIntent.setAction(Intent.ACTION_SEND)
                    shareIntent.putExtra(Intent.EXTRA_STREAM, filesToShare[1])
                   else
                    shareIntent.setAction(Intent.ACTION_SEND_MULTIPLE)
                    shareIntent.putParcelableArrayListExtra(
                    Intent.EXTRA_STREAM, ArrayList(filesToShare))
                  end
                  shareIntent.setType("*/*")
                  shareIntent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)

                  local pkg = packageMap[title]
                  if pkg then shareIntent.setPackage(pkg) end

                  pcall(function()
                    if #filesToShare == 1 and not pkg then
                      service.startActivity(
                      Intent.createChooser(shareIntent, "Share File"))
                     else
                      service.startActivity(shareIntent)
                    end
                  end)
                 else
                  Toast.makeText(this, "No valid file(s) to share", 0).show()
                end
              end
              return true
            end
          })

          popup.show()
        end,
        layout_width = "0dp",
        layout_weight = 0.33,
        layout_height = "match_parent",
        backgroundColor = "0xFFFF5252",
        textColor = "#FFFFFF",
        textSize = "18sp",
        gravity = "center",
        padding = "8dp",
      },
    },
    {
      ListView,
      id = "menuList",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      layout_marginTop = "10dp",
      dividerHeight = 1,
      backgroundColor = "0xFF000000",
    }
  }

  local view = loadlayout(toolsView)
  adapter = ArrayAdapter(this,
  android.R.layout.simple_list_item_multiple_choice,
  currentlyDisplayedItems)
  menuList.setAdapter(adapter)
  menuList.setChoiceMode(AbsListView.CHOICE_MODE_MULTIPLE)

  searchInput.addTextChangedListener{
    onTextChanged = function(s, start, before, count)
      local query = tostring(s):lower()
      local filteredItems = {}
      for _, name in ipairs(menuItems) do
        if name:lower():find(query, 1, true) then
          table.insert(filteredItems, name)
        end
      end

      currentlyDisplayedItems = filteredItems

      adapter = ArrayAdapter(this,
      android.R.layout.simple_list_item_multiple_choice,
      currentlyDisplayedItems)
      menuList.setAdapter(adapter)
      menuList.setChoiceMode(AbsListView.CHOICE_MODE_MULTIPLE)
      selectedPositions.clear()
      textview_button.setText("Manage Recordings (" ..
      #currentlyDisplayedItems .. ")")
      service.postSpeak(100, tostring(#currentlyDisplayedItems))
    end
  }

  menuList.setOnItemClickListener(AdapterView.OnItemClickListener{
    onItemClick = function(parent, view, position, id)
      if menuList.isItemChecked(position) then
        selectedPositions.put(position, true)
       else
        selectedPositions.delete(position)
      end
      local count = selectedPositions.size()
      textview_button.setText("Manage Recordings (" ..
      count .. " selected)")
      if count > 0 then
        service.postSpeak(300, count .. " item selected")
       else
        textview_button.setText("Manage Recordings (" ..
        #currentlyDisplayedItems .. ")")
        service.postSpeak(300, "No item selected")
      end
    end
  })

  menuList.setOnItemLongClickListener(AdapterView.OnItemLongClickListener{
    onItemLongClick = function(parent, view, position, id)
      if lastLongPressed == nil then
        lastLongPressed = position
        menuList.setItemChecked(position, true)
        selectedPositions.put(position, true)
        service.postSpeak(300, "Selection started")
       else
        local startPos = math.min(lastLongPressed, position)
        local endPos = math.max(lastLongPressed, position)

        for i = startPos, endPos do
          menuList.setItemChecked(i, true)
          selectedPositions.put(i, true)
        end

        service.postSpeak(300, "Selected from " ..
        (startPos + 1) .. " to " .. (endPos + 1) .. ".")
        lastLongPressed = nil
      end
      textview_button.setText("Manage Recordings (" ..
      selectedPositions.size() .. " selected)")
      return true
    end
  })

  dlg.setView(view)
  dlg.show()
end








function setRecordingSettings()
  require "import"
  import "android.widget.Button"
  import "android.widget.LinearLayout"
  import "com.androlua.LuaDialog"


  local mainOptions = {          
    ["toggle Recording"]  = "toggleRecording",
    ["Audio Recordings"]  = "audioRecorderPro",
    ["Recording options"] = "recordingOptions",
}

  local cancelOptions = {
    ["Recording options"] = "recordingOptions",
    ["Audio Recordings"] = "audioRecorderPro",
    ["Recording options"] = "recordingOptions"
  }
  local discardOptions = {
    ["No Action"] = "nullFunc",
    ["Audio Recordings"] = "audioRecorderPro"
  }
  local stopOptions = {
    ["No Action"] = "nullFunc",
    ["Audio Recordings"] = "audioRecorderPro"
  }

  local repeatOptions = {
  }
  function reverseTable(t)
    local reversed = {}
    for k, v in pairs(t) do
      reversed[v] = k
    end
    return reversed
  end
local mainLabels   = reverseTable(mainOptions)
  local cancelLabels = reverseTable(cancelOptions)
  local discardLabels = reverseTable(discardOptions)
  local stopLabels = reverseTable(stopOptions)
  local repeatLabels = reverseTable(repeatOptions)


  local layout = {
    LinearLayout,
    orientation = "vertical",
    {
      Button,
      id = "btnSaveSource",
      layout_width = "match_parent",
      text = "MIC",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("MIC")
        menu.add("CAMCORDER")
        menu.add("VOICE_RECOGNITION")
        menu.add("VOICE_COMMUNICATION")
        menu.add("VOICE_CALL")
        menu.add("DEFAULT")
        menu.add("UNPROCESSED")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())
            local sourceMap = {
              MIC = tostring(MediaRecorder.AudioSource.MIC),
              CAMCORDER = tostring(MediaRecorder.AudioSource.CAMCORDER),
              VOICE_RECOGNITION = tostring(MediaRecorder.AudioSource.VOICE_RECOGNITION),
              VOICE_COMMUNICATION = tostring(MediaRecorder.AudioSource.VOICE_COMMUNICATION),
              VOICE_CALL = tostring(MediaRecorder.AudioSource.VOICE_CALL),
              DEFAULT = tostring(MediaRecorder.AudioSource.DEFAULT),
              UNPROCESSED = tostring(MediaRecorder.AudioSource.UNPROCESSED)
            }

            local selectedSource = sourceMap[title]
            if selectedSource then
              prefsEditor.putString("audio_source", selectedSource)
              prefsEditor.apply()
              btnSaveSource.setText(title)
              service.postSpeak(200, "Source saved: " .. title)
             else
              service.postSpeak(200, "Failed to save source")

            end

            return true
          end
        })

        popup.show()
      end
    },
    {
      Button,
      layout_width = "match_parent",
      id = "btnBitrateSelect",
      text = "128 KBPS",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("32 kbps")
        menu.add("64 kbps")
        menu.add("96 kbps")
        menu.add("128 kbps")
        menu.add("160 kbps")
        menu.add("192 kbps")
        menu.add("256 kbps")
        menu.add("320 kbps")
        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            local bitrateMap = {
              ["32 kbps"] = "32000",
              ["64 kbps"] = "64000",
              ["96 kbps"] = "96000",
              ["128 kbps"] = "128000",
              ["160 kbps"] = "160000",
              ["192 kbps"] = "192000",
              ["256 kbps"] = "256000",
              ["320 kbps"] = "320000"
            }

            local bitrateValue = bitrateMap[title]
            if bitrateValue then
              prefsEditor.putString("audio_encoding_bitrate", bitrateValue)
              prefsEditor.apply()
              btnBitrateSelect.setText(title)
              service.postSpeak(200, "Saved: " .. title)
            end

            return true
          end
        })

        popup.show()


      end
    },
    {
      Button,
      layout_width = "match_parent",
      id = "btnSamplingRate",
      text = "Sampling Rate",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        local rates = {"8000", "16000", "22050", "32000", "44100", "48000"}
        for i, rate in ipairs(rates) do
          menu.add(rate .. " Hz")
        end

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())
            local value = title:match("(%d+)")
            if value then
              prefsEditor.putString("audio_sampling_rate", value)
              prefsEditor.apply()
              btnSamplingRate.setText(title)
              service.postSpeak(200, "Saved: " .. title)
            end
            return true
          end
        })

        popup.show()
      end
    },
    {
      Button,
      layout_width = "match_parent",
      id = "btnChannelSelect",
      text = "STEREO",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("Stereo")
        menu.add("Mono")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            if title == "Stereo" then
              prefsEditor.putString("audio_channels", "2")
              prefsEditor.apply()
              btnChannelSelect.setText("Stereo")
              service.postSpeak(200, "Saved: Stereo")
             elseif title == "Mono" then
              prefsEditor.putString("audio_channels", "1")
              prefsEditor.apply()
              btnChannelSelect.setText("Mono")
              service.postSpeak(200, "Saved: Mono")
            end

            return true
          end
        })

        popup.show()

      end
},
    {
      Button,
      id = "btnVADSwitch",
      layout_width = "match_parent",
      text = "Voice-Activated Recording: " .. (vadEnabled and "ON" or "OFF"),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        vadEnabled = not vadEnabled
        prefsEditor.putString("vad_enabled", tostring(vadEnabled))
prefsEditor.apply()
        btnVADSwitch.setText("Voice-Activated Recording: " .. (vadEnabled and "ON" or "OFF"))
        service.postSpeak(200, vadEnabled and "Voice activated recording enabled" or "Voice activated recording disabled")
      end
    },
    {
      Button,
      id = "btnVADSilence",
      layout_width = "match_parent",
      text = "Silence duration: " .. tostring(vadSilenceMs/1000) .. " s",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnVADSilence)
        local menu  = popup.getMenu()
        for _, sec in ipairs({1,2,3,5,7,10}) do
          menu.add(tostring(sec) .. " seconds")
        end
        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local val = tonumber(tostring(item.getTitle()):match("(%d+)"))
            if val then
              vadSilenceMs = val * 1000
              prefsEditor.putString("vad_silence_ms", tostring(vadSilenceMs))
prefsEditor.apply()
              btnVADSilence.setText("Silence duration: " .. val .. " s")
              service.postSpeak(200, "Silence duration set to " .. val .. " seconds")
            end
            return true
          end
        })
        popup.show()
      end
    },
    {
      Button,
      id = "btnVADThreshold",
      layout_width = "match_parent",
      text = "Sound threshold: " .. tostring(vadThreshold),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnVADThreshold)
        local menu  = popup.getMenu()
        for _, th in ipairs({50,100,150,200,300,400,500,600,700,800,900,1000,2000,3000,4000,5000,10000,15000,}) do
          menu.add(tostring(th))
        end
        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local th = tonumber(tostring(item.getTitle()))
            if th then
              vadThreshold = th
              prefsEditor.putString("vad_threshold", tostring(vadThreshold))
prefsEditor.apply()
              btnVADThreshold.setText("Sound threshold: " .. tostring(vadThreshold))
              service.postSpeak(200, "Threshold set to " .. tostring(vadThreshold))
            end
            return true
          end
        })
        popup.show()
      end
    },
    {
      Button,
      layout_width = "match_parent",
      text = currentFilePath,
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        dialog.dismiss()
        manageFolderPath()
      end
    },

    {
      Button,
      layout_width = "match_parent",
      id = "btnDefaultActionSelect",
text = "Default start: " ..              (mainLabels[prefs.getString("main_function", "toggleRecording")] or "Unknown"),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("toggle Recording")
        menu.add("Audio Recordings")
        menu.add("Recording options")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            if title == "toggle Recording" then
              prefsEditor.putString("main_function", "toggleRecording")
              prefsEditor.apply()
              btnDefaultActionSelect.setText("Default start: toggle Recording")
              service.postSpeak(200, "Saved: toggle Recording")
             elseif title == "Audio Recordings" then
              prefsEditor.putString("main_function", "audioRecorderPro")
              prefsEditor.apply()
              btnDefaultActionSelect.setText("Default start: Audio Recordings")
              service.postSpeak(200, "Saved: Audio Recordings")
             elseif title == "Recording options" then
              prefsEditor.putString("main_function", "recordingOptions")
              prefsEditor.apply()
              btnDefaultActionSelect.setText("Default start: Recording options")
              service.postSpeak(200, "Saved: Recording options")
            end

            return true
          end
        })

        popup.show()

      end
    },
    {
      Button,
      layout_width = "match_parent",
      id = "btnDefaultCancelSelect",
      text = "Cancel recording start: " .. (cancelLabels[prefs.getString("cancel_function", cancelFunctionName)] or "Unknown"),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("Recording options")
        menu.add("Audio Recordings")
        menu.add("Recording options")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            if title == "Recording options" then
              prefsEditor.putString("cancel_function", "recordingOptions")
              prefsEditor.apply()
              btnDefaultCancelSelect.setText("Cancel recording start: Recording options")
              service.postSpeak(200, "Saved: Recording options")
             elseif title == "Audio Recordings" then
              prefsEditor.putString("cancel_function", "audioRecorderPro")
              prefsEditor.apply()
              btnDefaultCancelSelect.setText("Cancel recording start: Audio Recordings")
              service.postSpeak(200, "Saved: Audio Recordings")
             elseif title == "custom Recording" then
              prefsEditor.putString("cancel_function", "recordingOptions")
              prefsEditor.apply()
              btnDefaultCancelSelect.setText("Cancel recording start: Recording options")
              service.postSpeak(200, "Saved: Recording options")
            end

            return true
          end
        })

        popup.show()

      end
    },
    {
      Button,
      layout_width = "match_parent",
      id = "btnDefaultDiscardSelect",
      text = "Discard recording: " .. (discardLabels[prefs.getString("discard_function", discardFunctionName)] or "Unknown"),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("No Action")
        menu.add("Audio Recordings")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            if title == "No Action" then
              prefsEditor.putString("discard_function", "nullFunc")
              prefsEditor.apply()
              btnDefaultDiscardSelect.setText("Discard recording: No Action")
              service.postSpeak(200, "Saved: No Action")
             elseif title == "Audio Recordings" then
              prefsEditor.putString("discard_function", "audioRecorderPro")
              prefsEditor.apply()
              btnDefaultDiscardSelect.setText("Discard recording: Audio Recordings")
              service.postSpeak(200, "Saved: Audio Recordings")
            end

            return true
          end
        })

        popup.show()

      end
    },

    {
      Button,
      layout_width = "match_parent",
      id = "btnDefaultStopSelect",
      text = "Stop recording: " .. (stopLabels[prefs.getString("stop_function", stopFunctionName)] or "Unknown"),
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        local popup = PopupMenu(this, btnSaveSource)
        local menu = popup.getMenu()

        menu.add("No Action")
        menu.add("Audio Recordings")

        popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
          onMenuItemClick = function(item)
            local title = tostring(item.getTitle())

            if title == "No Action" then
              prefsEditor.putString("stop_function", "nullFunc")
              prefsEditor.apply()
              btnDefaultStopSelect.setText("Stop recording: No Action")
              service.postSpeak(200, "Saved: No Action")
             elseif title == "Audio Recordings" then
              prefsEditor.putString("stop_function", "audioRecorderPro")
              prefsEditor.apply()
              btnDefaultStopSelect.setText("Stop recording: Audio Recordings")
              service.postSpeak(200, "Saved: Audio Recordings")
            end

            return true
          end
        })

        popup.show()

      end
    },
    {
      Button,
      layout_width = "match_parent",
      text = "info",
      textColor = "0xFFFF5252",
      backgroundColor = "0xFF000000",
      onClick = function()
        info()
      end
    },
  }

  dialog = LuaDialog(this)
  dialog.setView(loadlayout(layout))


  local savedSource = prefs.getString("audio_source", tostring(MediaRecorder.AudioSource.MIC))
  local sourceNameMap = {
    [tostring(MediaRecorder.AudioSource.MIC)] = "MIC",
    [tostring(MediaRecorder.AudioSource.CAMCORDER)] = "CAMCORDER",
    [tostring(MediaRecorder.AudioSource.VOICE_RECOGNITION)] = "VOICE_RECOGNITION",
    [tostring(MediaRecorder.AudioSource.VOICE_COMMUNICATION)] = "VOICE_COMMUNICATION",
    [tostring(MediaRecorder.AudioSource.VOICE_CALL)] = "VOICE_CALL",
    [tostring(MediaRecorder.AudioSource.DEFAULT)] = "DEFAULT",
    [tostring(MediaRecorder.AudioSource.UNPROCESSED)] = "UNPROCESSED"
  }
  btnSaveSource.setText(sourceNameMap[savedSource] or "Select recording source")


  local bitrateValue = prefs.getString("audio_encoding_bitrate", "128000")
  local bitrateTextMap = {
    ["32000"] = "32 kbps",
    ["64000"] = "64 kbps",
    ["96000"] = "96 kbps",
    ["128000"] = "128 kbps",
    ["160000"] = "160 kbps",
    ["192000"] = "192 kbps",
    ["256000"] = "256 kbps",
    ["320000"] = "320 kbps"
  }
  btnBitrateSelect.setText(bitrateTextMap[bitrateValue] or "Select bitrate")


  local savedSamplingRate = prefs.getString("audio_sampling_rate", "44100")
  btnSamplingRate.setText(savedSamplingRate .. " Hz")


  local savedChannel = prefs.getString("audio_channels", "2")
  if savedChannel == "1" then
    btnChannelSelect.setText("Mono")
   else
    btnChannelSelect.setText("Stereo")
  end
  dialog.show()
end





function shareAllRecordings()
  require "import"
  import "com.androlua.*"
  import "android.content.Intent"
  import "android.os.Handler"
  import "android.os.Looper"
  import "java.io.File"
  import "android.content.Context"
  import "android.os.PowerManager"

  local renamedFilePath = ""

  task(300, function()
    local datetime = os.date("%d-%m-%Y %H:%M")
    local pathFrom = currentFilePath
    local pathTo = "/storage/emulated/0/Documents"
    LuaUtil.zip(pathFrom, pathTo)
  end)

  task(3000, function()
    local datetime = os.date("%d-%m-%Y_%H_%M")
    local oldPath = currentFilePath .. ".zip"
    local newPath = "/storage/emulated/0/Documents/audio_recordings_" .. datetime .. ".zip"
    local success, err = os.rename(oldPath, newPath)
    if success then
      service.speak("All audio files have been saved in a compressed file named: Audio_Recordings_" .. datetime .. ".zip. You can now share it with an external app.")
      renamedFilePath = newPath
     else
      service.speak("An error occurred while renaming the file: " .. err)
    end
  end)

  task(5000, function()
    local handler = Handler(Looper.getMainLooper())
    local function checkSpeakingStatus()
      if not service.isSpeaking() then
        if renamedFilePath ~= "" then
          local file = File(renamedFilePath)
          local uri = this.getUriForFile(file)
          local intent = Intent(Intent.ACTION_SEND)
          intent.setType("application/zip")
          intent.putExtra(Intent.EXTRA_STREAM, uri)
          intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)

          local powerManager = this.getSystemService(Context.POWER_SERVICE)
          local wakeLock = powerManager.newWakeLock(
          PowerManager.SCREEN_DIM_WAKE_LOCK + PowerManager.ACQUIRE_CAUSES_WAKEUP,
          "MyApp:ShareWakeLock"
          )
          wakeLock.acquire(3000)

          local chooser = Intent.createChooser(intent, "Share file with...")
          chooser.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
          this.startActivity(chooser)
         else
          service.speak("No file available to share.")
        end
       else
        handler.postDelayed(checkSpeakingStatus, 1000)
      end
    end
    handler.postDelayed(checkSpeakingStatus, 1500)
  end)
end










function audioRecorderPro()

  local savedSeekSeconds = tonumber(prefs.getString("seek_seconds", "10000"))
  local lastPlayingFile = prefs.getString("current_playing_file", nil)
  local lastFileName = nil
  if lastPlayingFile then
    lastFileName = lastPlayingFile:match("([^/]+)%.%w+$")
  end

  function stopAll()
    if mp and not isCompleted then
      local currentPos
      if isPaused then
        currentPos = seekBar.getProgress() 
       else
        currentPos = mp.getCurrentPosition() 
      end
      prefs.edit().putInt("last_position", currentPos).apply()
    end
    task(400,function()
      if mp then
        pcall(function()
          mp.stop()
          mp.release()
        end)
        mp = nil
      end
    end)
  end




  local dirPath = currentFilePath
  local dir = File(dirPath)
  if not dir.exists() then
    dir.mkdirs()
  end

  local path = currentFilePath
  local fullFileList = io.ls(path)


  menuItems = {}
  fileMap = {}


  local displayedItems = displayedItems or {}
  local pointA = nil
  local pointB = nil
  local repeatAB = false
  local loopRunnable


  for _, filename in ipairs(fullFileList) do
    local nameOnly = filename:match("(.+)%..+$") or filename
    table.insert(menuItems, nameOnly)
    fileMap[nameOnly] = filename
  end


  displayedItems = menuItems




  function sortMenuItems()
    if sortMode == "alphabetical_az" then
      table.sort(menuItems, function(a, b)
        return a:lower() < b:lower()
      end)
     elseif sortMode == "alphabetical_za" then
      table.sort(menuItems, function(a, b)
        return a:lower() > b:lower()
      end)
     elseif sortMode == "size_desc" then
      table.sort(menuItems, function(a, b)
        local fa = File(path .. "/" .. (fileMap[a] or ""))
        local fb = File(path .. "/" .. (fileMap[b] or ""))
        local sizeA = (fa.exists() and fa.length()) or 0
        local sizeB = (fb.exists() and fb.length()) or 0
        return sizeA > sizeB
      end)

     elseif sortMode == "size_asc" then
      table.sort(menuItems, function(a, b)
        local fa = File(path .. "/" .. (fileMap[a] or ""))
        local fb = File(path .. "/" .. (fileMap[b] or ""))
        local sizeA = (fa.exists() and fa.length()) or 0
        local sizeB = (fb.exists() and fb.length()) or 0
        return sizeA < sizeB
      end)
     elseif sortMode == "date_oldest" then
      table.sort(menuItems, function(a, b)
        local fa = File(path .. "/" .. (fileMap[a] or ""))
        local fb = File(path .. "/" .. (fileMap[b] or ""))
        local timeA = (fa.exists() and fa.lastModified()) or 0
        local timeB = (fb.exists() and fb.lastModified()) or 0
        return timeA < timeB
      end)
     elseif sortMode == "date_newest" then
      table.sort(menuItems, function(a, b)
        local fa = File(path .. "/" .. (fileMap[a] or ""))
        local fb = File(path .. "/" .. (fileMap[b] or ""))
        local timeA = (fa.exists() and fa.lastModified()) or 0
        local timeB = (fb.exists() and fb.lastModified()) or 0
        return timeA > timeB
      end)
    end
  end




  function updateListView()
    local fullFileList = io.ls(path)
    local tempList = {}
    for _, filename in ipairs(fullFileList) do
      local nameOnly = filename:match("(.+)%..+$") or filename
      table.insert(tempList, nameOnly)
    end
    menuItems = {}
    for _, v in ipairs(tempList) do
      table.insert(menuItems, v)
    end
    sortMenuItems()
    fileMap = {}
    for _, name in ipairs(menuItems) do
      for _, filename in ipairs(fullFileList) do
        local nameOnly = filename:match("(.+)%..+$") or filename
        if nameOnly == name then
          fileMap[name] = filename
          break
        end
      end
    end
    displayedItems = menuItems 
    adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, displayedItems)
    menuList.setAdapter(adapter)
    if textview_button then
      textview_button.setText("Audio Recordings (" .. #displayedItems .. ")")
    end
  end




  sortMenuItems()

  function displayTrackInfo(filePath)
    if not filePath or not File(filePath).exists() then
      Toast.makeText(this, "No file information available.", 0).show()
      return
    end
    local file = File(filePath)
    local fileName = file.getName()
    local fileSize = file.length()
    local lastModified = file.lastModified()
    local formattedSize
    if fileSize < 1024 then
      formattedSize = string.format("%d Bytes", fileSize)
     elseif fileSize < 1024 * 1024 then
      formattedSize = string.format("%.2f KB", fileSize / 1024)
     elseif fileSize < 1024 * 1024 * 1024 then
      formattedSize = string.format("%.2f MB", fileSize / (1024 * 1024))
     else
      formattedSize = string.format("%.2f GB", fileSize / (1024 * 1024 * 1024))
    end
    local dateFormat = SimpleDateFormat("dd-MM-yyyy HH:mm:ss")
    local creationDate = Date(lastModified)
    local formattedDate = dateFormat.format(creationDate)
    local audioDuration = 0
    if mp and currentFile == filePath then
      audioDuration = mp.getDuration()
     else
      local tempMp = MediaPlayer()
      pcall(function()
        tempMp.setDataSource(filePath)
        tempMp.prepare()
        audioDuration = tempMp.getDuration()
        tempMp.release()
      end)
    end
    local formattedDuration = formatTime(audioDuration)
    local retriever = MediaMetadataRetriever()
    pcall(function()
      retriever.setDataSource(filePath)
    end)
    local bitrate = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_BITRATE)
    local codec = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_MIMETYPE)
    local sampleRate = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_SAMPLERATE)
    retriever.release()
    local formattedChannels = "Unknown"
    pcall(function()
      local MediaExtractor = luajava.bindClass("android.media.MediaExtractor")
      local extractor = MediaExtractor()
      extractor.setDataSource(filePath)
      local format = extractor.getTrackFormat(0)
      local channelCount = format.getInteger("channel-count")
      if channelCount == 1 then
        formattedChannels = "Mono (1 Channel)"
       elseif channelCount == 2 then
        formattedChannels = "Stereo (2 Channels)"
       else
        formattedChannels = channelCount .. " Channels"
      end
      extractor.release()
    end)
    local formattedBitrate = bitrate and string.format("%.2f kbps", tonumber(bitrate) / 1000) or "Unknown"
    local formattedCodec = codec or "Unknown"
    local formattedSampleRate = sampleRate and (sampleRate .. " Hz") or "Unknown"
    print("File Name: " .. fileName)
    print("Size: " .. formattedSize)
    print("Last Modified: " .. formattedDate)
    print("Duration: " .. formattedDuration)
    print("Codec: " .. formattedCodec)
    print("Bitrate: " .. formattedBitrate)
    print("Sampling Rate: " .. formattedSampleRate)
    print("Channels: " .. formattedChannels)
  end





  function formatTime(ms)
    local totalSeconds = math.floor(ms / 1000)
    local hours = math.floor(totalSeconds / 3600)
    local minutes = math.floor((totalSeconds % 3600) / 60)
    local seconds = totalSeconds % 60
    return string.format("%02d:%02d:%02d ", hours, minutes, seconds)
  end
  function formatSeekSeconds(ms)
    local seconds = math.floor(ms / 1000)
    if seconds >= 60 and seconds % 60 == 0 then
      local minutes = seconds / 60
      return minutes .. (minutes == 1 and " minute" or " minutes")
     else
      return seconds .. (seconds == 1 and " second" or " seconds")
    end
  end

  local seekAmountText = formatSeekSeconds(savedSeekSeconds)


  function toggleRepeatMode()
    repeatMode = (repeatMode + 1) % 4
    local messages = {
      [0] = "Play current track once",
      [1] = "Repeat current track",
      [2] = "Play all once",
      [3] = "Repeat all"
    }
    service.postSpeak(100, messages[repeatMode])
  end




  function rewind()
    if not mp then return end
    local currentPosition = mp.getCurrentPosition()
    local newPosition = math.max(0, currentPosition - savedSeekSeconds)
    mp.seekTo(newPosition)
  end

  function forward()
    if not mp then return end
    local currentPosition = mp.getCurrentPosition()
    local duration = mp.getDuration()
    local newPosition = math.min(duration, currentPosition + savedSeekSeconds)
    mp.seekTo(newPosition)
  end



  function setupSeekDefaults(view)
    local popup = PopupMenu(this, view)
    local menu = popup.getMenu()
    local options = {
      ["5 seconds"] = 5000,
      ["10 seconds"] = 10000,
      ["15 seconds"] = 15000,
      ["20 seconds"] = 20000,
      ["30 seconds"] = 30000,
      ["60 seconds"] = 60000,
      ["5 minutes"] = 300000,
      ["10 minutes"] = 600000
    }
    local orderedLabels = {
      "5 seconds",
      "10 seconds",
      "15 seconds",
      "20 seconds",
      "30 seconds",
      "60 seconds",
      "5 minutes",
      "10 minutes"
    }
    for _, label in ipairs(orderedLabels) do
      menu.add(label)
    end
    popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
      onMenuItemClick = function(item)
        local title = tostring(item.getTitle())
        local millis = options[title]
        if millis then
          prefs.edit().putString("seek_seconds", tostring(millis)).apply()
          rewindBtn.setContentDescription("Rewind (" .. title .. ")")
          forwardBtn.setContentDescription("Forward (" .. title .. ")")
          dlg.dismiss() stopAll() task(200,function() audioRecorderPro() end)
        end
        return true
      end
    })
    popup.show()
    return true
  end

  function previousTrack()
    if currentIndex > 1 then
      currentIndex = currentIndex - 1
      local previousFile = path .. "/" .. fileMap[menuItems[currentIndex]]
      playAudio(previousFile)
     else
      service.postSpeak(100, "This is the first track.")
    end
  end



  function nextTrack()
    if currentIndex < #menuItems then
      currentIndex = currentIndex + 1
      local nextFile = path .. "/" .. fileMap[menuItems[currentIndex]]
      playAudio(nextFile)
     else
      service.postSpeak(100, "This is the last track.")
    end
  end







  function togglePlaybackSpeed()
    if not mp then return end
    local speeds = {0.5, 0.75, 1.0, 1.05, 1.25, 1.5, 1.75, 2.0, 2.25, 2.5, 2.75, 3.0,}
    local currentSpeed = mp.getPlaybackParams().getSpeed()
    local nextIndex = 1
    for i, speed in ipairs(speeds) do
      if speed > currentSpeed and math.abs(currentSpeed - speed) > 0.01 then
        nextIndex = i
        break
      end
    end
    local newSpeed = speeds[nextIndex]
    savedSpeed = newSpeed
    local wasPlaying = mp.isPlaying()
    local params = mp.getPlaybackParams()
    params.setSpeed(newSpeed)
    mp.setPlaybackParams(params)
    if not wasPlaying then
      mp.start()
      mp.pause()
    end
    service.postSpeak(100, tostring(newSpeed))
    speedBtn.setContentDescription("Speed: " .. tostring(newSpeed))
  end

  function togglePlaybackPitch()
    if not mp then return end
    local pitches = {0.5, 0.75, 0.76, 0.77, 0.78, 0.79, 0.80, 0.81, 0.82, 0.83, 0.84, 0.85, 0.86, 0.87, 0.88, 0.89, 0.90, 0.91, 0.92, 0.93, 0.94, 0.95, 0.96, 0.97, 0.98, 0.99, 1.0, 1.01, 1.02, 1.03, 1.04, 1.05, 1.06, 1.07, 1.08, 1.09, 1.10, 1.11, 1.12, 1.13, 1.14, 1.15, 1.16, 1.17, 1.18, 1.19, 1.20, 1.21, 1.22, 1.23, 1.24, 1.25, 1.5, 1.75, 2.0}
    local currentPitch = mp.getPlaybackParams().getPitch()
    local nextIndex = 1
    for i, pitch in ipairs(pitches) do
      if pitch > currentPitch and math.abs(currentPitch - pitch) > 0.01 then
        nextIndex = i
        break
      end
    end
    local newPitch = pitches[nextIndex]
    savedPitch = newPitch
    local wasPlaying = mp.isPlaying()
    local params = mp.getPlaybackParams()
    params.setPitch(newPitch)
    params.setSpeed(savedSpeed or 1.0)
    mp.setPlaybackParams(params)
    if not wasPlaying then
      mp.start()
      mp.pause()
    end
    service.postSpeak(100, tostring(newPitch))
    pitchBtn.setContentDescription("Pitch: " .. tostring(newPitch))
  end





  function resetPlaybackSpeed()
    if not mp then return end
    local wasPlaying = mp.isPlaying()
    local params = mp.getPlaybackParams()
    params.setSpeed(1.0)
    mp.setPlaybackParams(params)
    if not wasPlaying then
      mp.pause()
    end
    service.postSpeak(100, "Speed reset to 1.0")
    speedBtn.setContentDescription("Speed: 1.0")
  end

  function resetPlaybackPitch()
    if not mp then return end
    local wasPlaying = mp.isPlaying()
    local params = mp.getPlaybackParams()
    params.setPitch(1.0)
    params.setSpeed(1.0) 
    mp.setPlaybackParams(params)
    if not wasPlaying then
      mp.pause()
    end
    service.postSpeak(100, "Pitch reset to 1.0")
    pitchBtn.setContentDescription("Pitch: 1.0")
  end





  function playAudio(filePath, ignoreLastPosition)
    local nameOnly = filePath:match("([^/]+)%.%w+$") or filePath
    currentName = nameOnly
    if mp and currentFile == filePath then
      if isCompleted then
        mp.seekTo(0)
        mp.start()
        smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
        isPaused = false
        isCompleted = false
        mainHandler.post(updateSeekBarRunnable)
       elseif isPaused then
        local newPos = seekBar.getProgress()
        mp.seekTo(newPos)
        mp.start()
        smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
        isPaused = false
        mainHandler.post(updateSeekBarRunnable)
       else
        mp.pause()
        isPaused = true
        smallButton.setBackgroundColor(0xFFFF9800)
smallButton.setContentDescription("Resume")
smallButton.setText("▶")
      end
      return
    end
    if mp then
      pcall(function()
        mp.stop()
        mp.release()
      end)
      mp = nil
    end
    mp = MediaPlayer()
    mp.setDataSource(filePath)
    mp.prepare()
    if not ignoreLastPosition then
      local lastPosition = prefs.getInt("last_position", 0)
      if lastPosition > 0 then
        mp.seekTo(lastPosition)
      end
    end
    local params = mp.getPlaybackParams()
    if keepSpeedPitch then
      params.setSpeed(savedSpeed)
      params.setPitch(savedPitch)
     else
      params.setSpeed(1.0)
      params.setPitch(1.0)
    end
    mp.setPlaybackParams(params)
    mp.start()
    prefs.edit().putString("current_playing_file", filePath).apply()
    smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
    isPaused = false
    isCompleted = false
    currentFile = filePath
    local duration = mp.getDuration()
    seekBar.setMax(duration)
    if trackInfoTextView then
      trackInfoTextView.setContentDescription("(Current recording: " .. nameOnly)
      trackInfo.setBackgroundColor(0xFF4CAF50)
    end
    local updateInterval = 500
    updateSeekBarRunnable = Runnable{
      run = function()
        if mp and mp.isPlaying() then
          local currentPosition = mp.getCurrentPosition()
          seekBar.setProgress(currentPosition)
          durationText.setText(formatTime(currentPosition) .. " / " .. formatTime(mp.getDuration()))
          mainHandler.postDelayed(updateSeekBarRunnable, updateInterval)
        end
      end
    }
    mainHandler.post(updateSeekBarRunnable)
    mp.setOnCompletionListener {
      onCompletion = function()
        isCompleted = true
        isPaused = false

        prefs.edit().putInt("last_position", 0).apply()
        if trackInfoTextView then
          trackInfoTextView.setContentDescription(nameOnly .. " (Completed)")
          trackInfo.setBackgroundColor(0xFF4CAF50)
        end
        smallButton.setBackgroundColor(0xFFFF0000)
smallButton.setContentDescription("play")
smallButton.setText("▶")

        if repeatMode == 1 then
          mp.seekTo(0)
          mp.start()
          smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
          isCompleted = false
          mainHandler.post(updateSeekBarRunnable)

         elseif repeatMode == 2 or repeatMode == 3 then
          for i, name in ipairs(menuItems) do
            if fileMap[name] == File(currentFile).getName() then
              currentIndex = i
              break
            end
          end
          currentIndex = currentIndex + 1

          if currentIndex > #menuItems then
            if repeatMode == 3 then
              currentIndex = 1 
             else
              return 
            end
          end

          local nextFile = path .. "/" .. fileMap[menuItems[currentIndex]]
          playAudio(nextFile)
        end
      end
    }
  end




  function deleteRecordingsOnly()
    local confirmDialog = LuaDialog(this)
    confirmDialog.setTitle("Confirm Deletion")
    confirmDialog.setMessage("Are you sure you want to delete all recordings?")
    confirmDialog.setButton("Yes", function()
      local function deleteFilesOnly(dirPath)
        local dir = File(dirPath)
        if dir.exists() and dir.isDirectory() then
          local files = dir.listFiles()
          if files ~= nil then
            for _, file in ipairs(luajava.astable(files)) do
              if file.isFile() then
                file.delete()
              end
            end
          end
        end
      end
      local targetPath = currentFilePath
      deleteFilesOnly(targetPath)
      service.postSpeak(600, "All files in the folder have been successfully deleted.")
      dlg.dismiss()
    end)
    confirmDialog.setButton2("No", nil)
    confirmDialog.show()
  end







  dlg = LuaDialog(this)
  local toolsView = {
    LinearLayout,
    orientation = 1, 
    layout_width = "match_parent",
    layout_height = "wrap_content",
    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      gravity = "center_vertical", 
      {
        TextView,
        id = "textview_button",
        text = "Audio Recordings (" .. #menuItems .. ")",
        layout_width = "0dp",
        layout_height = "wrap_content",
        layout_weight = 0.85,
        gravity = "center",
        textSize = "30sp",
        textColor = 0xFFFF5252,
        backgroundColor = 0xFF000000,
        padding = "8dp",
        onClick = function(v)
          print(sortMode)
        end,
        onLongClickListener = {
          onLongClick = function(v)
            local popup = PopupMenu(this, v)
            local menu = popup.getMenu()

            menu.add("Sort: Alphabetically (A → Z)")
            menu.add("Sort: Alphabetically (Z → A)")
            menu.add("Sort: By Size (Largest → Smallest)")
            menu.add("Sort: By Size (Smallest → Largest)")
            menu.add("Sort: By Date (Oldest → Newest)")
            menu.add("Sort: By Date (Newest → Oldest)")

            popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
              onMenuItemClick = function(item)
                local title = tostring(item.getTitle())

                if title == "Sort: Alphabetically (A → Z)" then
                  sortMode = "alphabetical_az"
                 elseif title == "Sort: Alphabetically (Z → A)" then
                  sortMode = "alphabetical_za"
                 elseif title == "Sort: By Size (Largest → Smallest)" then
                  sortMode = "size_desc"
                 elseif title == "Sort: By Size (Smallest → Largest)" then
                  sortMode = "size_asc"
                 elseif title == "Sort: By Date (Oldest → Newest)" then
                  sortMode = "date_oldest"
                 elseif title == "Sort: By Date (Newest → Oldest)" then
                  sortMode = "date_newest"
                end
                if title:find("Sort:") then
                  updateListView()
                  prefs.edit().putString("sortMode", sortMode).apply() 
                end

                return true
              end
            })

            popup.show()
            return true
          end
        },
      },
      {
        Button,
        id = "more_button",
        text = "锔",
        textSize = "35sp",
        layout_width = "wrap_content", 
        layout_height = "wrap_content",
        backgroundColor = 0xFF000000,
        contentDescription = "More options",
        gravity = "center",
        onClick = function(v)
          local popup = PopupMenu(this, v)
          local menu = popup.getMenu()
          menu.add("Timer & Exit")
          menu.add("manage Recordings")
          menu.add("Settings")
          menu.add("Help")
          popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
            onMenuItemClick = function(item)
              local title = tostring(item.getTitle())
              if title == "Timer & Exit" then
                if _G.activeTaskRunning then
                  _G.activeTaskRunning = false
                  service.postSpeak(300, "Exit timer cancelled")
                 else
                  local popup = PopupMenu(v.getContext(), v)
                  local menu = popup.getMenu()

                  local items = {
                    "00:15", "00:30", "01:00", "02:00",
                    "03:00", "04:00", "05:00", "06:00"
                  }
                  for _, item in ipairs(items) do
                    menu.add(item)
                  end
                  popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
                    onMenuItemClick = function(item)
                      local title = tostring(item.getTitle())
                      if title == "00:15" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(900000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "00:30" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(1800000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "01:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(3600000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "02:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(7200000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "03:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(10800000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "04:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(14400000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "05:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(18000000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       elseif title == "06:00" then
                        _G.activeTaskRunning = true
                        service.postSpeak(300, "Exit timer started")
                        task(21600000, function()
                          _G.activeTaskRunning = false
                          stopAll()
                        end)
                       else
                        print("مدة غير معروفة: " .. title)
                      end
                      return true
                    end
                  })
                  popup.show()
                end



               elseif title == "manage Recordings" then
                dlg.dismiss() stopAll() manageRecordings()
               elseif title == "Settings" then
                dlg.dismiss() stopAll() setRecordingSettings()
               elseif title == "Help" then
                help()
              end

              return true
            end
          })

          popup.show()
          return true
        end
      },
    },
    {
      EditText,
      id = "searchInput",
      hint = "Search by letters or numbers.",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      backgroundColor = 0xFF0D47A1,
      padding = "8dp",
      textSize = "18sp",
    },
    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      layout_height = "48dp",
      padding = "4dp",
      {
        TextView,
        id = "smallButton",
        layout_width = "48dp",
        layout_height = "48dp",
        gravity = "center",
        text = "▶",
        contentDescription = "play ",
        textSize = "22sp",
        backgroundColor = "0xFF000000",
        textColor = "#FFFFFF",
        onClick = function(v)
          if mp then
            if isCompleted then
              mp.seekTo(0)
              mp.start()
              smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
              isPaused = false
              isCompleted = false
              mainHandler.post(updateSeekBarRunnable)
             elseif isPaused then
              local seekToPosition = seekBar.getProgress()
              mp.seekTo(seekToPosition)
              mp.start()
              smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
              isPaused = false
              mainHandler.post(updateSeekBarRunnable)
             elseif mp.isPlaying() then
              mp.pause()
              isPaused = true
              smallButton.setBackgroundColor(0xFFFF9800)
smallButton.setContentDescription("Resume")
smallButton.setText("▶")
            end
           else
            local fullPath = lastPlayingFile
            playAudio(fullPath)
          end
        end,
        onLongClickListener = {
          onLongClick = function(v)
            if mp then
              if isCompleted or isPaused then
                mp.seekTo(0)
                mp.start()
                smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
                isPaused = false
                isCompleted = false
                mainHandler.post(updateSeekBarRunnable)
               elseif mp.isPlaying() then
                mp.stop()
                mp.prepare()
                seekBar.setProgress(0)
                smallButton.setBackgroundColor(0xFFFF0000)
smallButton.setContentDescription("play")
smallButton.setText("▶")
                durationText.setText(formatTime(0) .. " / " .. formatTime(mp.getDuration()))
                isPaused = false
                isCompleted = true
               else
                mp.seekTo(0)
                mp.start()
                smallButton.setBackgroundColor(0xFF4CAF50)
smallButton.setContentDescription("pause")
smallButton.setText("⏸")
                isPaused = false
                isCompleted = false
                mainHandler.post(updateSeekBarRunnable)
              end
             else
              Toast.makeText(this, "No audio is currently loaded.", 0).show()
            end
            return true
          end
        },
      },
      {
        SeekBar,
        id = "seekBar",
        layout_width = "0dp", 
        layout_weight = 1, 
        layout_height = "match_parent",
        backgroundColor = "0xFF000000",

      },
      {
        TextView,
        id = "durationText",
        layout_width = "wrap_content",
        layout_height = "wrap_content",
        gravity = "center",
        textColor = "#FFFFFF",
        textSize = "14sp",
        backgroundColor = 0xFF000000,
        text = "00:00 / 00:00",
        padding = "4dp",
onClick = function(v)
  if not pointA then
    pointA = seekBar.getProgress()
    service.postSpeak(200, "Start set.")
  elseif not pointB then
    pointB = seekBar.getProgress()
    if pointB <= pointA then
      service.postSpeak(200, "End point must be after start.")
      pointB = nil
      return true
    end
    repeatAB = true
    service.postSpeak(200, "End set.")
    mp.seekTo(pointA)
    mp.start()
    isPaused = false
    smallButton.setBackgroundColor(0xFF4CAF50)
    smallButton.setContentDescription("pause")
    smallButton.setText("⏸")
    loopRunnable = Runnable{
      run = function()
        if mp and repeatAB then
          if mp.getCurrentPosition() >= pointB then
            mp.seekTo(pointA)
            mp.start()
          end
          mainHandler.postDelayed(loopRunnable, 200)
        end
      end
    }
    mainHandler.post(loopRunnable)
  else
    repeatAB = false
    pointA, pointB = nil, nil
    service.postSpeak(200, "Loop off.")
  end
end,

      },
    },

    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      backgroundColor = "0xFF222222",
      padding = "4dp",
      {
        TextView,
        id = "rec",
        contentDescription = "Recording options",
        layout_width = "0dp",
        layout_height = "48dp", 
        layout_weight = 1,
        textSize = "14sp",
        backgroundColor = "0xFF8B0000",
        onClick = function(v)
recordingOptions()
          dlg.dismiss()
          stopAll()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            changeFolderPath()
            dlg.dismiss()
            stopAll()
            return true
          end
        },
      },
      {
        TextView,
        id = "trackInfo",
        layout_width = "0dp",
        layout_height = "48dp", 
        layout_weight = 1,
        contentDescription = "Last File: " .. (lastFileName or "睾賷乇 賲鬲賵賮乇"),
        textColor = "0xFFFFFFFF",
        textSize = "16sp",
        onClick = function(v)
          toggleRepeatMode()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            local popup = PopupMenu(this, v)
            local menu = popup.getMenu()
            menu.add("info")
            menu.add("Play current track once")
            menu.add("Repeat current track")
            menu.add("Play all once")
            menu.add("Repeat all")
            menu.add("Keep the pitch and speed rate for all tracks")
            popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
              onMenuItemClick = function(item)
                local title = tostring(item.getTitle())
                if title == "info" then
                  if mp and currentFile then
                    displayTrackInfo(currentFile)
                   else
                    Toast.makeText(this, "No track is currently playing.", 0).show()
                  end
                 elseif title == "Play current track once" then
                  prefs.edit().putString("repeat_mode", "0").apply() dlg.dismiss() stopAll() task(500,function() audioRecorderPro() end)
                 elseif title == "Repeat current track" then
                  prefs.edit().putString("repeat_mode", "11").apply() dlg.dismiss() stopAll() task(500,function() audioRecorderPro() end)
                 elseif title == "Play all once" then
                  prefs.edit().putString("repeat_mode", "2").apply() dlg.dismiss() stopAll() task(500,function() audioRecorderPro() end)
                 elseif title == "Repeat all" then
                  prefs.edit().putString("repeat_mode", "3").apply() dlg.dismiss() stopAll() task(500,function() audioRecorderPro() end)
                 elseif title == "Keep the pitch and speed rate for all tracks" then
                  local current = prefs.getString("keep_speed_pitch", "true")
                  local newValue = (current == "true") and "false" or "true"
                  prefs.edit().putString("keep_speed_pitch", newValue).apply()
                  dlg.dismiss() stopAll() task(500,function() audioRecorderPro() end)
                  if newValue == "true" then
                    service.postSpeak(800, "Keep speed and pitch is now ON")
                   else
                    service.postSpeak(800, "Keep speed and pitch is now OFF")
                  end
                end
                return true
              end
            })
            popup.show()
            return true
          end
        },
      },
      {
        TextView,
        id = "pitchBtn",
        contentDescription = "pitch",
        layout_width = "0dp",
        layout_height = "48dp", 
        layout_weight = 1,
        backgroundColor = "0xFF673AB7",
        onClick = function(v)
          togglePlaybackPitch()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            resetPlaybackPitch()
            return true
          end
        },
      },
      {
        TextView,
        id = "speedBtn",
        contentDescription = "speed",
        layout_width = "0dp",
        layout_height = "48dp",
        layout_weight = 1,
        backgroundColor = "0xFF0097A7",
        onClick = function(v)
          togglePlaybackSpeed()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            resetPlaybackSpeed()
            return true
          end
        },
      },
    },

    {
      LinearLayout,
      orientation = "horizontal",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      backgroundColor = "0xFF222222",
      padding = "4dp",
      {
        TextView,
        id = "rewindBtn",
        contentDescription = "Rewind " .. seekAmountText,
        layout_width = "0dp",
        layout_height = "48dp",
        layout_weight = 1,
        textColor = "0xFFFFFFFF",
        textSize = "16sp",
        gravity = "center",
        backgroundColor = "0xFF37474F", 
        onClick = function(v)
          rewind()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            setupSeekDefaults(v)
            return true
          end
        },
      },
      {
        TextView,
        id = "forwardBtn",
        contentDescription = "Forward " .. seekAmountText,
        layout_width = "0dp",
        layout_height = "48dp",
        layout_weight = 1,
        textColor = "0xFFFFFFFF",
        textSize = "16sp",
        gravity = "center",
        backgroundColor = "0xFF33691E",
        onClick = function(v)
          forward()
        end,
        onLongClickListener = {
          onLongClick = function(v)
            setupSeekDefaults(v)
            return true
          end
        },
      },
      {
        TextView,
        id = "prevTrackBtn",
        contentDescription = "Previous track",
        layout_width = "0dp",
        layout_height = "48dp",
        layout_weight = 1,
        textColor = "0xFFFFFFFF",
        textSize = "16sp",
        gravity = "center",
        backgroundColor = "0xFF6A1B9A", 
        onClick = function(v)
          previousTrack()
        end,
      },
      {
        TextView,
        id = "nextTrackBtn",
        contentDescription = "Next track",
        layout_width = "0dp",
        layout_height = "48dp",
        layout_weight = 1,
        textColor = "0xFFFFFFFF",
        textSize = "16sp",
        gravity = "center",
        backgroundColor = "0xFF0D47A1",
        onClick = function(v)
          nextTrack()
        end,
      },
    },
    {
      ListView,
      id = "menuList",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      layout_marginTop = "10dp",
      dividerHeight = 1,
      backgroundColor = "0xFF000000",
    }
  }
  local view = loadlayout(toolsView)
  trackInfoTextView = trackInfo
  local isSeeking = false
  seekBar.setOnSeekBarChangeListener{
    onStartTrackingTouch = function(sb)
      isSeeking = true
    end,
    onStopTrackingTouch = function(sb)
      local progress = sb.getProgress()
      if mp then
        mp.seekTo(progress)
      end
      isSeeking = false
    end,
    onProgressChanged = function(sb, progress, fromUser)
      if fromUser and mp then
        pcall(function()
          service.postSpeak(400, formatTime(progress) .. " / " .. formatTime(mp.getDuration()))
          durationText.setText(formatTime(progress) .. " / " .. formatTime(mp.getDuration()))
        end)
      end
      if mp and mp.isPlaying() and fromUser and not isSeeking then
        mp.seekTo(progress)
      end
    end
  }
  local adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, menuItems)
  menuList.setAdapter(adapter)
  searchInput.addTextChangedListener{
    onTextChanged = function(s, start, before, count)
      local query = tostring(s):lower()
      local filteredItems = {}
      for i, name in ipairs(menuItems) do
        if name:lower():find(query, 1, true) then
          table.insert(filteredItems, name)
        end
      end
      displayedItems = filteredItems 
      adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, displayedItems)
      menuList.setAdapter(adapter)

      textview_button.setText("Audio Recordings (" .. #displayedItems .. ")")
      if #displayedItems ~= lastCount then
        lastCount = #displayedItems
        local speakText = (#displayedItems == 0) and "No results found. " or "Results: " .. #displayedItems
        service.postSpeak(200, speakText)
      end
    end
  }

  menuList.setOnItemClickListener{
    onItemClick = function(parent, view, position, id)
      local displayName = displayedItems[position + 1] 
      local actualFile = fileMap[displayName]
      local fullPath = path .. File.separator .. actualFile
      playAudio(fullPath, true)
    end
  }


  menuList.setOnItemLongClickListener(AdapterView.OnItemLongClickListener{
    onItemLongClick = function(parent, view, position, id)
      local popup = PopupMenu(this, view)
      local menu = popup.getMenu()
      menu.add("info")
      menu.add("Rename")
      menu.add("open folder")
      menu.add("Share")
      menu.add("Share via Telegram")
      menu.add("Share via WhatsApp")
      menu.add("Share via Messenger")
      menu.add("Share via driv")
      menu.add("Rename then Share")
      menu.add("Share all")
      menu.add("Delete all")
      menu.add("Delete")

      popup.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener{
        onMenuItemClick = function(item)
          local title = tostring(item.getTitle())
          local selectedItemText = displayedItems[position + 1]
          if title == "info" then
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. File.separator .. actualFile
            local file = File(fullPath)

            if not file.exists() then
              Toast.makeText(this, "No file information available.", 0).show()
              return
            end

            local fileName = file.getName()
            local fileSize = file.length()
            local lastModified = file.lastModified()

            local formattedSize
            if fileSize < 1024 then
              formattedSize = string.format("%d Bytes", fileSize)
             elseif fileSize < 1024 * 1024 then
              formattedSize = string.format("%.2f KB", fileSize / 1024)
             elseif fileSize < 1024 * 1024 * 1024 then
              formattedSize = string.format("%.2f MB", fileSize / (1024 * 1024))
             else
              formattedSize = string.format("%.2f GB", fileSize / (1024 * 1024 * 1024))
            end

            local dateFormat = SimpleDateFormat("dd-MM-yyyy HH:mm:ss")
            local formattedDate = dateFormat.format(Date(lastModified))

            local audioDuration = 0
            local tempMp = MediaPlayer()
            pcall(function()
              tempMp.setDataSource(fullPath)
              tempMp.prepare()
              audioDuration = tempMp.getDuration()
              tempMp.release()
            end)
            local formattedDuration = formatTime(audioDuration)

            local retriever = MediaMetadataRetriever()
            pcall(function()
              retriever.setDataSource(fullPath)
            end)
            local bitrate = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_BITRATE)
            local codec = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_MIMETYPE)
            local sampleRate = retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_SAMPLERATE)
            retriever.release()

            local formattedChannels = "Unknown"
            pcall(function()
              local MediaExtractor = luajava.bindClass("android.media.MediaExtractor")
              local extractor = MediaExtractor()
              extractor.setDataSource(fullPath)
              local format = extractor.getTrackFormat(0)
              local channelCount = format.getInteger("channel-count")
              if channelCount == 1 then
                formattedChannels = "Mono (1 Channel)"
               elseif channelCount == 2 then
                formattedChannels = "Stereo (2 Channels)"
               else
                formattedChannels = channelCount .. " Channels"
              end
              extractor.release()
            end)

            local formattedBitrate = bitrate and string.format("%.2f kbps", tonumber(bitrate) / 1000) or "Unknown"
            local formattedCodec = codec or "Unknown"
            local formattedSampleRate = sampleRate and (sampleRate .. " Hz") or "Unknown"

            print("File Name: " .. fileName)
            print("Size: " .. formattedSize)
            print("Last Modified: " .. formattedDate)
            print("Duration: " .. formattedDuration)
            print("Codec: " .. formattedCodec)
            print("Bitrate: " .. formattedBitrate)
            print("Sampling Rate: " .. formattedSampleRate)
            print("Channels: " .. formattedChannels)
            return

           elseif title == "Rename" then
            local actualFile = fileMap[selectedItemText]
            local oldFullPath = path .. File.separator .. actualFile
            local oldFile = File(oldFullPath)
            local renameViews = {}
            local renameDialog
            local layout = {
              LinearLayout,
              orientation = "vertical",
              padding = "16dp",
              backgroundColor = 0xFF000000,
              {
                TextView,
                text = "Enter new name",
                textColor = 0xFFFFFFFF,
              },
              {
                EditText,
                id = "nameInput",
                hint = "New name",
                text = selectedItemText,
                backgroundColor = 0xFF0D47A1,
                textColor = 0xFFFFFFFF,
                layout_width = "match_parent",
              },
            }
            renameDialog = LuaDialog(this)
            renameDialog.setTitle("Rename")
            renameDialog.setView(loadlayout(layout, renameViews))
            renameDialog.setButton("Confirm", function()
              local newName = tostring(renameViews.nameInput.getText()):match("^%s*(.-)%s*$")
              if newName == "" then
                Toast.makeText(this, "New name is empty", 0).show()
                return
              end
              local extension = actualFile:match("^.+(%..+)$") or ""
              local newFullPath = path .. File.separator .. newName .. extension
              local newFile = File(newFullPath)
              if newFile.exists() then
                Toast.makeText(this, "A file with the same name exists", 0).show()
                return
              end
              local success = oldFile.renameTo(newFile)
              if success then
                Toast.makeText(this, "Renamed successfully", 0).show()
                fullFileList = io.ls(path)
                menuItems = {}
                fileMap = {}
                for _, filename in ipairs(fullFileList) do
                  local nameOnly = filename:match("(.+)%..+$") or filename
                  table.insert(menuItems, nameOnly)
                  fileMap[nameOnly] = filename
                end
                adapter.clear()
                adapter.addAll(menuItems)
                adapter.notifyDataSetChanged()
                textview_button.setText("Audio Recordings (" .. #menuItems .. ")")
               else
                Toast.makeText(this, "Rename failed", 0).show()
              end
            end)
            renameDialog.setButton2("Cancel", nil)
            renameDialog.show()

           elseif title == "open folder" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)

            if file.exists() then
              local parentPath = file.getParent()
              local parentUri = Uri.parse(parentPath)

              local intent = Intent(Intent.ACTION_VIEW)
              intent.setDataAndType(parentUri, "resource/folder")
              intent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)

              if intent.resolveActivity(service.getPackageManager()) then
                service.startActivity(intent)
               else
                service.asyncSpeak("賱丕 賷賵噩丿 鬲胤亘賷賯 賷賲賰賳賴 賮鬲丨 賴匕丕 丕賱賲噩賱丿.")
              end
             else
              Toast.makeText(this, "丕賱賲賱賮 睾賷乇 賲賵噩賵丿", 0).show()
            end

           elseif title == "Share" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)
            if file.exists() then
              local uri = service.getUriForFile(file)
              local share = Intent(Intent.ACTION_SEND)
              share.setType("*/*")
              share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
              share.putExtra(Intent.EXTRA_STREAM, uri)
              service.startActivity(Intent.createChooser(share, "Share File"))
             else
              Toast.makeText(this, "File does not exist", 0).show()
            end
           elseif title == "Share via Telegram" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)
            if file.exists() then
              local uri = service.getUriForFile(file)
              local share = Intent(Intent.ACTION_SEND)
              share.setType("*/*")
              share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
              share.putExtra(Intent.EXTRA_STREAM, uri)
              share.setPackage("org.telegram.messenger")
              pcall(function()
                service.startActivity(share)
              end)
             else
              Toast.makeText(this, "File does not exist", 0).show()
            end
           elseif title == "Share via WhatsApp" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)
            if file.exists() then
              local uri = service.getUriForFile(file)
              local share = Intent(Intent.ACTION_SEND)
              share.setType("*/*")
              share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
              share.putExtra(Intent.EXTRA_STREAM, uri)
              share.setPackage("com.whatsapp")
              pcall(function()
                service.startActivity(share)
              end)
             else
              Toast.makeText(this, "File does not exist", 0).show()
            end
           elseif title == "Share via Messenger" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)
            if file.exists() then
              local uri = service.getUriForFile(file)
              local share = Intent(Intent.ACTION_SEND)
              share.setType("*/*")
              share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
              share.putExtra(Intent.EXTRA_STREAM, uri)
              share.setPackage("com.facebook.orca")
              pcall(function()
                service.startActivity(share)
              end)
             else
              Toast.makeText(this, "File does not exist", 0).show()
            end
           elseif title == "Share via driv" then
            dlg.dismiss() stopAll()
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. "/" .. actualFile
            local file = File(fullPath)
            if file.exists() then
              local uri = service.getUriForFile(file)
              local share = Intent(Intent.ACTION_SEND)
              share.setType("*/*")
              share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
              share.putExtra(Intent.EXTRA_STREAM, uri)
              share.setPackage("com.google.android.apps.docs")
              pcall(function()
                service.startActivity(share)
              end)
             else
              Toast.makeText(this, "File does not exist", 0).show()
            end

           elseif title == "Rename then Share" then
            local actualFile = fileMap[selectedItemText]
            local oldFullPath = path .. File.separator .. actualFile
            local oldFile = File(oldFullPath)
            local renameViews = {}
            local renameDialog
            local layout = {
              LinearLayout,
              orientation = "vertical",
              padding = "16dp",
              backgroundColor = 0xFF000000,
              {
                TextView,
                text = "Enter new name",
                textColor = 0xFFFFFFFF,
              },
              {
                EditText,
                id = "nameInput",
                hint = "New name",
                text = selectedItemText,
                backgroundColor = 0xFF0D47A1,
                textColor = 0xFFFFFFFF,
                layout_width = "match_parent",
              },
            }
            renameDialog = LuaDialog(this)
            renameDialog.setTitle("Rename")
            renameDialog.setView(loadlayout(layout, renameViews))
            renameDialog.setButton("Confirm", function()
              local newName = tostring(renameViews.nameInput.getText()):match("^%s*(.-)%s*$")
              if newName == "" then
                Toast.makeText(this, "New name is empty", 0).show()
                return
              end
              local extension = actualFile:match("^.+(%..+)$") or ""
              local newFullPath = path .. File.separator .. newName .. extension
              local newFile = File(newFullPath)
              if newFile.exists() then
                Toast.makeText(this, "A file with the same name exists", 0).show()
                return
              end
              local success = oldFile.renameTo(newFile)
              if success then
                Toast.makeText(this, "Renamed successfully", 0).show()
                dlg.dismiss() stopAll()
                fullFileList = io.ls(path)
                menuItems = {}
                fileMap = {}
                for _, filename in ipairs(fullFileList) do
                  local nameOnly = filename:match("(.+)%..+$") or filename
                  table.insert(menuItems, nameOnly)
                  fileMap[nameOnly] = filename
                end
                adapter.clear()
                adapter.addAll(menuItems)
                adapter.notifyDataSetChanged()
                textview_button.setText("Audio Recordings (" .. #menuItems .. ")")
                local fileToShare = File(newFullPath)
                if fileToShare.exists() then
                  local uri = service.getUriForFile(fileToShare)
                  local share = Intent(Intent.ACTION_SEND)
                  share.setType("*/*")
                  share.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                  share.putExtra(Intent.EXTRA_STREAM, uri)
                  service.startActivity(Intent.createChooser(share, "Share File"))
                 else
                  Toast.makeText(this, "Renamed file not found", 0).show()
                end
               else
                Toast.makeText(this, "Rename failed", 0).show()
              end
            end)
            renameDialog.setButton2("Cancel", nil)
            renameDialog.show()

           elseif title == "Delete" then
            local actualFile = fileMap[selectedItemText]
            local fullPath = path .. File.separator .. actualFile
            local fileToDelete = File(fullPath)
            local confirmDialog = LuaDialog(this)
            confirmDialog.setTitle("Confirm Deletion")
            confirmDialog.setMessage("Are you sure you want to delete this recording?")
            confirmDialog.setButton("Yes", function()
              if fileToDelete.exists() and fileToDelete.delete() then
                Toast.makeText(this, "File deleted", 0).show()
                fullFileList = io.ls(path)
                menuItems = {}
                fileMap = {}
                for _, filename in ipairs(fullFileList) do
                  local nameOnly = filename:match("(.+)%..+$") or filename
                  table.insert(menuItems, nameOnly)
                  fileMap[nameOnly] = filename
                end
                displayedItems = menuItems 
                adapter.clear()
                adapter.addAll(menuItems)
                adapter.notifyDataSetChanged()
                textview_button.setText("Audio Recordings (" .. #menuItems .. ")")
               else
                Toast.makeText(this, "Failed to delete file", 0).show()
              end
            end)
            confirmDialog.setButton2("No", nil)
            confirmDialog.show()

           elseif title == "Share all" then
            shareAllRecordings()
            dlg.dismiss() stopAll()

           elseif title == "Delete all" then
            deleteRecordingsOnly()
            dlg.dismiss() stopAll()
          end
          return true
        end
      })
      popup.show()
      return true
    end
  })



  dlg.setView(view)
  dlg.show()




  dlg.setOnKeyListener(luajava.createProxy("android.content.DialogInterface$OnKeyListener", {
    onKey = function(dialog, keyCode, event)
      if keyCode == 4 then
        dlg.dismiss()
        stopAll()
        return true
      end
      return false
    end
  }))

end







local toneGenerator = ToneGenerator(AudioManager.STREAM_ACCESSIBILITY, 100)
local context = this
if _G.recorder == nil then
  _G.recorder = nil
end
if _G.isRecording == nil then
  _G.isRecording = false
end
if _G.hasStartedRecording == nil then
  _G.hasStartedRecording = false
end
if _G.isPaused == nil then
  _G.isPaused = false
end
if _G.isCountdownActive == nil then
  _G.isCountdownActive = false
end
if _G.scheduledTasks == nil then
  _G.scheduledTasks = {}
end

function hasMultipleMics()
  local audioManager = context.getSystemService(Context.AUDIO_SERVICE)
  local devices = audioManager.getDevices(AudioManager.GET_DEVICES_INPUTS)
  local micCount = 0
  for i = 0, #devices - 1 do
    local dev = devices[i]
    if dev.getType() == AudioDeviceInfo.TYPE_BUILTIN_MIC then
      micCount = micCount + 1
    end
  end
  return micCount >= 2
end

function cancelCountdown()
  for _, t in ipairs(_G.scheduledTasks) do
    pcall(function() t.stop() end)
  end
  _G.isPaused = false
  _G.scheduledTasks = {}
  _G.isCountdownActive = false
  _G.hasStartedRecording = false
  _G.isRecording = false
  if _G.recorder ~= nil then
    local success, err = pcall(function() _G.recorder.release() end)
    if not success then
      Toast.makeText(context, "Error releasing recorder on cancellation", 0).show()
    end
    _G.recorder = nil
  end
  deleteTempFile()
  service.play("cancel")
  service.postSpeak(500, "Recording has been cancelled.")
  task(1200,function()
    _G[cancelFunctionName]()
  end)

end

function deleteTempFile()
  local tempFilePath = currentFilePath .. "/temp_recording.mp3"
  local tempFile = File(tempFilePath)
  if tempFile.exists() then
    tempFile.delete()
  end
end




function recordingOptions()
  require "import"

  local confirmDialog = LuaDialog(this)
  confirmDialog.setTitle("Recording options")

  local scheduleNames = {}
  for _, item in ipairs(_G.pendingSchedules) do
    table.insert(scheduleNames, item.label)
  end

  local layout = {
    LinearLayout,
    orientation = "vertical",
    padding = "16dp",

    {
      TextView,
      id = "remainingTime",
      text = "Remaining: --:--",
      textSize = "16sp",
      textColor = 0xFFFFFFFF,
      layout_width = "wrap_content",
      layout_height = "wrap_content",
      layout_gravity = "center_horizontal",
      padding = "8dp",
    },

    {
      ProgressBar,
      id = "vuMeter",
      style="?android:attr/progressBarStyleHorizontal",
      layout_width="match_parent",
      layout_height="38dp",
      max=100,
      progress=0,
backgroundColor = 0xFF000000,
importantForAccessibility = "no",
    },

    {
      LinearLayout,
      orientation = "horizontal",
      layout_width  = "match_parent",
      layout_height = "wrap_content",
      gravity = "center",

      {
        Button,
        id = "freeRecording",
        text = "Start Recording",
        layout_width  = "0dp",
        layout_weight = 1,
        layout_height = "wrap_content",
        backgroundColor = 0xFFFF0000,
        textColor       = 0xFFFFFFFF,
        onClick = function()
          task(5500, function()
            if isCurrentlyRecording() then
            end
          end)
          toggleRecordingPreset()
        end,
      },

      {
        Button,
        id   = "btnSchedule",
        text = "Schedule recording",
        layout_width  = "0dp",
        layout_weight = 1,
        layout_height = "wrap_content",
        backgroundColor = 0xFFFF0000,
        textColor       = 0xFFFFFFFF,
        onClick = function() scheduleRecording() end,
      },
      {
        Button,
        id   = "btnPreset",
        text = "Preset recording",
        layout_width   = "0dp",
        layout_weight  = 1,
        layout_height  = "wrap_content",
        layout_marginLeft = "8dp",
        backgroundColor = 0xFFFF0000,
        textColor       = 0xFFFFFFFF,
        onClick = function(v) startRecordingWithAutoStop(v) end,
      },
    },

    {
      TextView,
      id = "txtInfo",
      text = (#scheduleNames > 0) and "Scheduled recordings:" or "No scheduled recordings",
      textSize = "18sp",
      textColor = 0xFFFFFFFF,
      layout_marginBottom = "8dp",
    },

    {
      ListView,
      id = "scheduleList",
      layout_width  = "match_parent",
      layout_height = (#scheduleNames > 0) and "120dp" or "0dp",
      backgroundColor = 0xFF000000,
    },
  }

  local views = {}
  confirmDialog.setView(loadlayout(layout, views))

  _G.remainingTime = views.remainingTime
  _G.freeRecording  = views.freeRecording

  local ArrayAdapter = luajava.bindClass("android.widget.ArrayAdapter")
  local adapter = ArrayAdapter(this, android.R.layout.simple_list_item_1, {})
  views.scheduleList.setAdapter(adapter)

  local function refreshAdapter()
    adapter.clear()
    for _, v in ipairs(scheduleNames) do adapter.add(v) end
    adapter.notifyDataSetChanged()
  end
  refreshAdapter()

  views.scheduleList.setOnItemClickListener(AdapterView.OnItemClickListener{
    onItemClick = function(_, _, position, _)
      local label = scheduleNames[position + 1] or "this schedule"

      local confirm = LuaDialog(this)
      confirm.setTitle("Cancel schedule")
      confirm.setMessage("Do you want to cancel the schedule \"" .. label .. "\"?")
      confirm.setButton("Yes", function()
        local item = _G.pendingSchedules[position + 1]
        if item and item.handler and item.job then
          item.handler.removeCallbacks(item.job)
        end
        table.remove(_G.pendingSchedules, position + 1)
        table.remove(scheduleNames,       position + 1)
        refreshAdapter()
        if #scheduleNames == 0 then
          views.txtInfo.setText("No scheduled recordings")
          views.scheduleList.getLayoutParams().height = 0
        end
        service.postSpeak(300, "Schedule cancelled.")
      end)
      confirm.setButton2("No", nil)
      confirm.show()
    end
  })

  confirmDialog.setButton ("Audio Recordings",  audioRecorderPro)
  confirmDialog.setButton2("Manage recordings", manageRecordings)
  confirmDialog.setButton3("Settings",          setRecordingSettings)

  local vuMeter      = views.vuMeter
  local vuHandler    = Handler(Looper.getMainLooper())
  local vuRunnable   = nil

  local function startVu()
    if vuRunnable then return end
    vuRunnable = luajava.createProxy("java.lang.Runnable",{
      run=function()
        if _G.recorder and _G.hasStartedRecording then
          local amp = _G.recorder.getMaxAmplitude()
          local level = math.min(100, math.floor(amp/327.67))
          vuMeter.setProgress(level)
        else
          vuMeter.setProgress(0)
        end
        vuHandler.postDelayed(vuRunnable,150)
      end
    })
    vuHandler.post(vuRunnable)
  end

  local function stopVu()
    if vuRunnable then
      vuHandler.removeCallbacks(vuRunnable)
      vuRunnable=nil
      vuMeter.setProgress(0)
    end
  end

  startVu()
  confirmDialog.setOnDismissListener(luajava.createProxy("android.content.DialogInterface$OnDismissListener",{onDismiss=function() stopVu() end}))

  confirmDialog.show()
end





function showRecordingControlDialog()
  Toast.makeText(context, "Recording Control Dialog", 0).show()
  local confirmDialog = LuaDialog(context)
  confirmDialog.setTitle("Recording Control")
  local timeTextView = TextView(context)
  timeTextView.setTextSize(20)
  timeTextView.setPadding(20, 20, 20, 20)
  timeTextView.setText("00:00:00")
  local function formatTime()
    local hours = math.floor(_G.elapsedSeconds / 3600)
    local minutes = math.floor((_G.elapsedSeconds % 3600) / 60)
    local seconds = _G.elapsedSeconds % 60
    return string.format("%02d:%02d:%02d", hours, minutes, seconds)
  end
  local uiHandler = Handler(Looper.getMainLooper())
  local function updateTimeTextView()
    timeTextView.setText(formatTime())
    if _G.isTimerRunning then
      uiHandler.postDelayed(updateTimeTextView, 1000)
    end
  end
  updateTimeTextView()
  confirmDialog.setView(timeTextView)
  confirmDialog.setButton("Resume", function()
    service.postSpeak(100," ")
    task(400,function()
      if _G.recorder and _G.isPaused then
        local success, err = pcall(function() _G.recorder.resume() end)
        if success then
          _G.isPaused = false
          toggleTimer()
         else
          Toast.makeText(context, "Failed to resume recording: " .. tostring(err), 1).show()
        end
      end
    end)
    toneGenerator.startTone(ToneGenerator.TONE_PROP_ACK, 200)
  end)

  confirmDialog.setButton2("Stop", function()
    if _G.recorder and _G.hasStartedRecording then
      local stop_success, stop_err = pcall(function() _G.recorder.stop() end)
      if not stop_success then
        Toast.makeText(context, "Error stopping recorder: " .. tostring(stop_err), 1).show()
      end
      toneGenerator.startTone(ToneGenerator.TONE_CDMA_CALLDROP_LITE, 200)
      local release_success, release_err = pcall(function() _G.recorder.release() end)
      if not release_success then
        Toast.makeText(context, "Error releasing recorder after stop: " .. tostring(release_err), 1).show()
      end
      local dateFormat = SimpleDateFormat("dd-MM-yyyy HH mm ss")
      local currentTime = Date()
      local formattedDate = dateFormat.format(currentTime)
      local newFileName = formattedDate .. ".mp3"
      local dirPath = currentFilePath
      local finalFilePath = dirPath .. "/" .. newFileName
      local tempFile = File(dirPath .. "/temp_recording.mp3")
      local newFile = File(finalFilePath)
      if tempFile.exists() then
        tempFile.renameTo(newFile)
        service.postSpeak(500, "Recording completed.")
        stopTimer()
        _G[stopFunctionName]()
       else
        service.postSpeak(500, "Recording completed, but temporary file not found.")
      end
     else
      service.postSpeak(500, "Recording has been cancelled.")
      service.play("cancel")
    end
    _G.recorder = nil
    _G.isRecording = false
    _G.hasStartedRecording = false
    _G.isCountdownActive = false
    _G.isPaused = false
    _G.scheduledTasks = {}
    deleteTempFile()
  end)
  confirmDialog.setButton3("Discard recording", function()
    local tempFilePath = currentFilePath .. "/temp_recording.mp3"
    local tempFile = File(tempFilePath)

    if tempFile.exists() then
      local deleted = tempFile.delete()
      if deleted then
        service.postSpeak(500, "Recording has been cancelled.")
        stopTimer()
        service.play("cancel")
        _G[discardFunctionName]()
       else
        service.postSpeak(500, "Failed to delete temporary recording.")
      end
     else
      service.postSpeak(500, "No temporary recording found.")
    end

    if _G.recorder then
      pcall(function() _G.recorder.release() end)
    end
    _G.recorder = nil
    _G.isRecording = false
    _G.hasStartedRecording = false
    _G.isCountdownActive = false
    _G.isPaused = false
    _G.scheduledTasks = {}
  end)
  confirmDialog.show()
end






function startVAD()
  if not vadEnabled or not _G.recorder then return end

  local threshold    = vadThreshold
  local silenceLimit = vadSilenceMs
  local silenceStart = nil
  local SystemClock  = luajava.bindClass("android.os.SystemClock")

  _vadRunnable = luajava.createProxy("java.lang.Runnable", {
    run = function()
      if _G.recorder and _G.hasStartedRecording then
        local amp = _G.recorder.getMaxAmplitude()

        if not _G.isPaused then
          if amp < threshold then
            silenceStart = silenceStart or SystemClock.uptimeMillis()
            if SystemClock.uptimeMillis() - silenceStart > silenceLimit then
              pcall(function() _G.recorder.pause() end)
              _G.isPaused = true
            end
          else
            silenceStart = nil
          end
        else
          if amp >= threshold then
            pcall(function() _G.recorder.resume() end)
            _G.isPaused = false
            silenceStart = nil
          end
        end
      end
      if _G.recorder then
        _vadHandler.postDelayed(_vadRunnable, 200)
      end
    end
  })

  _vadHandler.post(_vadRunnable)
end

function stopVAD()
  if _vadHandler and _vadRunnable then
    _vadHandler.removeCallbacks(_vadRunnable)
    _vadRunnable = nil
  end
end













function toggleRecordingPreset()
  local dirPath = currentFilePath
  local dir = File(dirPath)
  if not dir.exists() then
    dir.mkdirs()
  end

  if _G.isCountdownActive and not _G.hasStartedRecording then
    return
  end

  if _G.isRecording and _G.hasStartedRecording and not _G.isPaused then
    pcall(function() _G.recorder.stop() end)
    pcall(function() _G.recorder.release() end)
    stopVAD()
    stopTimer()

    _G.recorder = nil
    _G.isRecording = false
    _G.hasStartedRecording = false
    _G.isCountdownActive = false
    _G.isPaused = false
    _G.scheduledTasks = {}
    if _G.autoStopTask then
      pcall(function() _G.autoStopTask.stop() end)
      _G.autoStopTask = nil
    end
    _G.autoStopRemaining = nil
    _G.autoStopEndAt = nil

    local dateFormat = SimpleDateFormat("dd-MM-yyyy HH mm ss")
    local currentTime = Date()
    local formattedDate = dateFormat.format(currentTime)
    local newFileName = formattedDate .. ".mp3"
    local finalFilePath = dirPath .. "/" .. newFileName
    local tempFile = File(dirPath .. "/temp_recording.mp3")
    local newFile = File(finalFilePath)

    if tempFile.exists() then
      tempFile.renameTo(newFile)
      service.postSpeak(500, "Recording completed.")
      toneGenerator.startTone(ToneGenerator.TONE_CDMA_CALLDROP_LITE, 200)
      if freeRecording then freeRecording.setText("START RECORDING") end
    else
      service.postSpeak(500, "Recording completed, but temporary file not found.")
    end

    deleteTempFile()
    resetRemainingTime()
    return
  end

  if not _G.isRecording and not _G.isCountdownActive then
    _G.recorder = MediaRecorder()
    _G.recorder.setAudioSource(currentAudioSource)
    _G.recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    _G.recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    _G.recorder.setAudioEncodingBitRate(currentAudioEncodingBitRate)
    _G.recorder.setAudioSamplingRate(currentAudioSamplingRate)
    if not hasMultipleMics() and currentAudioChannels > 1 then
      currentAudioChannels = 1
    end
    pcall(function()
      _G.recorder.setAudioChannels(currentAudioChannels)
    end)

    local tempFilePath = dirPath .. "/temp_recording.mp3"
    _G.recorder.setOutputFile(tempFilePath)
    local success, err = pcall(function() _G.recorder.prepare() end)
    if not success then
      Toast.makeText(context, "Failed to prepare recorder: " .. tostring(err), 1).show()
      _G.recorder = nil
      _G.isRecording = false
      _G.hasStartedRecording = false
      _G.isCountdownActive = false
      _G.isPaused = false
      _G.scheduledTasks = {}
      deleteTempFile()
      resetRemainingTime()
      return
    end

    _G.isCountdownActive = true
    _G.hasStartedRecording = false
    _G.isPaused = false
    _G.isRecording = true
    _G.scheduledTasks = {}
    table.insert(_G.scheduledTasks, task(500,function()
      if freeRecording then freeRecording.setText("Countdown") end
      if _G.isCountdownActive then service.asyncSpeak("5") end
    end))
    table.insert(_G.scheduledTasks, task(1500,function()
      if _G.isCountdownActive then service.asyncSpeak("4") end
    end))
    table.insert(_G.scheduledTasks, task(2500,function()
      if _G.isCountdownActive then service.asyncSpeak("3") end
    end))
    table.insert(_G.scheduledTasks, task(3500,function()
      if _G.isCountdownActive then service.asyncSpeak("2") end
    end))
    table.insert(_G.scheduledTasks, task(4500,function()
      if _G.isCountdownActive then service.asyncSpeak("1") end
    end))
    table.insert(_G.scheduledTasks, task(5000,function()
      if _G.isCountdownActive and _G.recorder then
        local start_success, start_err = pcall(function() _G.recorder.start() end)
        if start_success then
          _G.hasStartedRecording = true
          startVAD()

          if _G.autoStopEndAt and remainingTime then
            local handler = mainHandler or Handler(Looper.getMainLooper())
            local function update()
              if _G.autoStopEndAt then
                local remainSec = math.floor((_G.autoStopEndAt - os.time()*1000) / 1000)
                if remainSec < 0 then remainSec = 0 end
                remainingTime.setText("Remaining: " .. formatCountdown(remainSec))
                if remainSec == 0 then return end
                handler.postDelayed(_G.updateRemainingRunnable, 1000)
              end
            end
            _G.updateRemainingRunnable = luajava.createProxy("java.lang.Runnable", { run = update })
            update()
          end

          toneGenerator.startTone(ToneGenerator.TONE_PROP_ACK, 200)
          if freeRecording then freeRecording.setText("STOP RECORDING") end
          toggleTimer()
        else
          Toast.makeText(context, "Failed to start recording: " .. tostring(start_err), 1).show()
          pcall(function() _G.recorder.release() end)
          _G.recorder = nil
          _G.isRecording = false
          _G.hasStartedRecording = false
          _G.isPaused = false
          _G.scheduledTasks = {}
        end
      end
      _G.isCountdownActive = false
      _G.scheduledTasks = {}
    end))
    service.postSpeak(20, (currentAudioChannels == 2 and "Stereo" or "Mono"))
  end
end

function toggleRecording()
  local dirPath = currentFilePath
  local dir = File(dirPath)
  if not dir.exists() then dir.mkdirs() end

  if _G.isPaused and _G.hasStartedRecording then
    showRecordingControlDialog()
    return
  end

  if _G.isCountdownActive and not _G.hasStartedRecording then
    cancelCountdown()
    return
  end

  if _G.isRecording and _G.hasStartedRecording and not _G.isPaused then
    local pause_success, pause_err = pcall(function() _G.recorder.pause() end)
    if pause_success then
      _G.isPaused = true

      if _G.autoStopEndAt then
        local now = os.time() * 1000
        _G.autoStopRemaining = math.max(0, _G.autoStopEndAt - now)
        if _G.autoStopTask then
          pcall(function() _G.autoStopTask.stop() end)
          _G.autoStopTask = nil
        end
        _G.autoStopEndAt = nil
      end

      toneGenerator.startTone(ToneGenerator.TONE_CDMA_CALLDROP_LITE, 200)
      service.postSpeak(500, "Recording paused.")
      showRecordingControlDialog()
      toggleTimer()
    else
      Toast.makeText(context, "Failed to pause recording: " .. tostring(pause_err), 1).show()
      if _G.recorder then
        pcall(function() _G.recorder.stop() end)
        pcall(function() _G.recorder.release() end)
      end
      stopVAD()
      _G.recorder = nil
      _G.isRecording = false
      _G.hasStartedRecording = false
      _G.isCountdownActive = false
      _G.isPaused = false
      _G.scheduledTasks = {}
      deleteTempFile()
    end
    return
  end

  if _G.isRecording and _G.hasStartedRecording and _G.isPaused then
    local resume_success, resume_err = pcall(function() _G.recorder.resume() end)
    if resume_success then
      _G.isPaused = false

      if _G.autoStopRemaining and _G.autoStopRemaining > 0 then
        _G.autoStopEndAt = os.time() * 1000 + _G.autoStopRemaining
        _G.autoStopTask = task(_G.autoStopRemaining, function()
          if isCurrentlyRecording() then
            toggleRecordingPreset()
          end
        end)
        _G.autoStopRemaining = nil
      end

      toneGenerator.startTone(ToneGenerator.TONE_PROP_ACK, 200)
      service.postSpeak(500, "Recording resumed.")
      toggleTimer()
    else
      Toast.makeText(context, "Failed to resume recording: " .. tostring(resume_err), 1).show()
    end
    return
  end

  if not _G.isRecording and not _G.isCountdownActive then
    _G.recorder = MediaRecorder()
    _G.recorder.setAudioSource(currentAudioSource)
    _G.recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    _G.recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    _G.recorder.setAudioEncodingBitRate(currentAudioEncodingBitRate)
    _G.recorder.setAudioSamplingRate(currentAudioSamplingRate)
    if not hasMultipleMics() and currentAudioChannels > 1 then
      currentAudioChannels = 1
    end
    pcall(function()
      _G.recorder.setAudioChannels(currentAudioChannels)
    end)

    local tempFilePath = dirPath .. "/temp_recording.mp3"
    _G.recorder.setOutputFile(tempFilePath)
    local success, err = pcall(function() _G.recorder.prepare() end)
    if not success then
      Toast.makeText(context, "Failed to prepare recorder: " .. tostring(err), 1).show()
      _G.recorder = nil
      _G.isRecording = false
      _G.hasStartedRecording = false
      _G.isCountdownActive = false
      _G.isPaused = false
      _G.scheduledTasks = {}
      deleteTempFile()
      return
    end

    _G.isCountdownActive = true
    _G.hasStartedRecording = false
    _G.isPaused = false
    _G.isRecording = true
    _G.scheduledTasks = {}

    table.insert(_G.scheduledTasks, task(500,function()
      if _G.isCountdownActive then service.asyncSpeak("5") end
    end))
    table.insert(_G.scheduledTasks, task(1500,function()
      if _G.isCountdownActive then service.asyncSpeak("4") end
    end))
    table.insert(_G.scheduledTasks, task(2500,function()
      if _G.isCountdownActive then service.asyncSpeak("3") end
    end))
    table.insert(_G.scheduledTasks, task(3500,function()
      if _G.isCountdownActive then service.asyncSpeak("2") end
    end))
    table.insert(_G.scheduledTasks, task(4500,function()
      if _G.isCountdownActive then service.asyncSpeak("1") end
    end))
    table.insert(_G.scheduledTasks, task(5000,function()
      if _G.isCountdownActive and _G.recorder then
        local start_success, start_err = pcall(function() _G.recorder.start() end)
        if start_success then
          _G.hasStartedRecording = true
          startVAD()
          toneGenerator.startTone(ToneGenerator.TONE_PROP_ACK, 200)
          if freeRecording then freeRecording.setText("STOP RECORDING") end
          toggleTimer()
        else
          Toast.makeText(context, "Failed to start recording: " .. tostring(start_err), 1).show()
          pcall(function() _G.recorder.release() end)
          _G.recorder = nil
          _G.isRecording = false
          _G.hasStartedRecording = false
          _G.isPaused = false
          _G.scheduledTasks = {}
        end
      end
      _G.isCountdownActive = false
      _G.scheduledTasks = {}
    end))

    service.postSpeak(20, (currentAudioChannels == 2 and "Stereo" or "Mono"))
  end
end




function help()
  local helpText = [[
هذه الإضافة تتيح لنا تسجيل الصوت بطرائقَ متعددة، وتشغيله، وإدارته، ومشاركته أيضًا. كما تحتوي على إعدادات التسجيل، ومعلومات حول الجودة. 
نستطيع استخدامها كمسجل للصوت, أو كمشغل للصوتيات, حسب الاحتياج وحسب السيناريو.
نستطيع فعل كل هذا عبر إيماءة واحدة فقط.
هذه الإضافة تحتوي على نوافذ متعددة وكل نافذة يتم شرحها بشكل مستقل.
1. عند استدعاء الإضافة، يبدأ العد التنازلي، وبعد انتهائه يبدأ التسجيل تلقائيًا. قبل البدء بالعد يخبرنا بعدد القنوات المستخدمة.
2. أثناء العد التنازلي (وقبل انتهائه)، إذا استُدعيت الإضافة مرة أخرى، يُلغى بدء التسجيل، وهنا إما أن تظهر شاشة الاختيارات، أو شاشة التسجيلات، أو شاشة التسجيل المخصص، وهذا السلوك يمكن تحديده من شاشة الإعدادات.
3. تحتوي نافذة الاختيارات على ما يلي: 
- الاختيار الاول: برمجة تسجيل يبدأ في وقت معين.
- الاختيار الثاني: بدء التسجيل ينتهي في وقت معين.
- الاختيار الثالث:قائمة التسجيلات المبرمجة يمكنك إلغاؤها من هذه النافذة.
الاختيار الرابع: قائمة التسجيلات، ويمكن الوصول اليه اختصارًا عبر التمرير للأسفل.
- الاختيار الخامس: إدارة التسجيلات, ويمكن الوصول إليه اختصارًا عبر التمرير للأعلى.
- الاختيار السادس: الإعدادات.
4. أثناء التسجيل، إذا استُدعيت الإضافة، يتم إيقاف التسجيل مؤقتًا وتظهر نافذة تخيّرنا بين استئناف التسجيل أو إيقافه أو إلغائه., وتعرض مدة التسجيل الحالي. وإذا أُغلِقت هذه النافذة، يبقى التسجيل معلقًا إلى حين استدعاء الإضافة مرة أخرى، لتظهر النافذة من جديد ونختار بين الاستئناف أو الإيقاف أو الإلغاء. بعد إنهاء التسجيل أو إلغائه، يمكننا تحديد الإجراء المناسب، إما أن يكون لا شيء، وإما أن تفتح شاشة التسجيلات، وهذا يمكن تحديده من شاشة الإعدادات.
5. يظهر عنوان نافذة التسجيلات عدد التسجيلات، سواء جميع التسجيلات أو التسجيلات التي تم العثور عليها أثناء البحث. والضغط المطول عليه يُمكّننا من اختيار الترتيب الإفتراضي حسب الاسم أو الحجم أو التاريخ، وهذا يكون عكسياً أيضاً.
6. عند الضغط على زر المزيد في  نافذة التسجيلات، يتم عرض عدة خيارات
- الخيار الأول:  لتشغيل مؤقت الإنهاء
- الخيار الثاني: لإدارة التسجيلات
- الخيار الثالث: للإعدادات.
- الخيار الرابع: للمساعدة.
7. تحت عنوان النافذة يوجد مربع تحرير للبحث عن التسجيلات حسب الأرقام، باستخدام  التاريخ، أو الوقت، أو حسب الحروف إذا تم تغيير اسم الملف. أثناء الكتابة في مربع البحث، يتم تصفية النتائج ويُعلن عن عدد النتائج التي تم العثور عليها.
8. أسفل مربع التحرير، في الجهة اليسرى، يوجد زر للتحكم بالتشغيل. - إذا كان هناك مقطع مشغّل مسبقًا، يمكن من خلال الزر إيقافه مؤقتًا أو استئناف التشغيل.  وسواء أثناء التشغيل أو التوقف المؤقت أو التام، يعرض هذا الزر المدة المنقضية والمدة الإجمالية. - عند الضغط المطول على الزر أثناء التشغيل، يتم إيقاف التشغيل تمامًا. - بعد انتهاء التشغيل، أو عند الإيقاف اليدوي أو المؤقت، يعيد الزر تشغيل المقطع من البداية.
9. عند فتح نافذة التسجيلات, وعدم اختيار أي مقطع, والضغط على زر التشغيل, فإنه سيستأنف تشغيل المقطع الذي تم إيقافه  عند الخروج من النافذة. فإذا أردنا تشغيله من البداية، فإننا نضغط عليه مطولاً ثم بعد ذلك نَنْقُرُ عليه مرتين.
10. بجانب زر التشغيل، يوجد شريط تمرير، يتيح التقديم أو الترجيع. أثناء  التقديم أو الترجيع، يتم الإعلان  عن المدة المنقضية والإجمالية. وبالنقر مرتين عليه: يتم تحديد نقطة البداية, ثم بالنقر مرة أخرى: يتم تحديد نقطة النهاية، ليتم التشغيل ما بين النقطتين تلقائياً مع التكرار. وبالنقر مرة أخرى يتم الرجوع إلى الوضع الافتراضي. كما  يمكن عبر الزر الموجود أسفل القائمة العامة  إدخال وقت معين لنقل المؤشر إليه مباشرة (مثلًا: لإيصال المؤشر إلى نهاية الدقيقة الرابعة، ندخل القيمة 240000).
11. أسفل زر التشغيل، يوجد زر التسجيل المخصص. بالنقر عليه مرتين، يتم فتح نافذة التسجيل المخصص، وبالضغط المطول عليه، يتم عرض قائمة تحتوي على المسارات التي تم تخزينها سابقاً ليتم اختيار أحدها.
12. بجانب زر التسجيل المخصص،  زر يظهر عنوان الملف الحالي المشغّل، أو عنوان الملف الأخير الذي تم تشغيله عند فتح النافذة.. عند الضغط عليه، يتم التبديل بين تشغيل المقطع الحالي مرة واحدة، أو تكراره، أو تشغيل جميع المقاطع، أو تكرار جميع المقاطع. وعند الضغط المطول عليه، يتم إظهار قائمة تحتوي على الأمور التالية:
- الاختيار الأول: لعرض معلومات الملف الحالي المشغّل.
- الاختيار الثاني: لتشغيل المقطع مرة واحدة افتراضياً عند استدعاء الإضافة.
- الاختيار الثالث: لتكرار تشغيل المقطع افتراضياً عند استدعاء الإضافة.
- الاختيار الرابع:  لتشغيل جميع المقاطع افتراضياً عند استدعاء الإضافة.
- الاختيار الخامس: لتكرار تشغيل جميع المقاطع افتراضياً عند استدعاء الإضافة.
- الاختيار السادس: للتبديل بين وضع الإحتفاظ بتغييرات الحدة والسرعة أثناء الانتقال إلى المقطع التالي أو السابق.
13. بجانبه يوجد زر للتحكم في حدة الصوت أثناء التشغيل، وبجانبه زر آخر للتحكم في السرعة. عند الضغط على أحدهما يتم تغيير القيمة، وعند الضغط المطول يتم اختيار القيمة الافتراضية.
14. تحت الأزرار السابقة نجد أربعة أزرار أخرى: من أجل الترجيع والتقديم, والمقطع السابق والمقطع التالي. بالضغط المطول على زر التقديم أو الترجيع، نستطيع ضبط الفاصل الزمني الافتراضي للتقديم أو الترجيع.
15. عند النقر مرتين على أي ملف في نافذة التسجيلات،يتم تشغيله أو إيقافهم مؤقتًا أو استئناف تشغيله. وعند الضغط المطول عليه تظهر نافذة تحتوي على الخيارات التالية:
- عرض معلومات المقطع الحالي.
- إعادة تسمية المقطع.
- فتح المجلد الهدف.
- مشاركته مع التطبيقات.
- مشاركته عبر Telegram.
- مشاركته عبر WhatsApp.
- مشاركته عبر Messenger.
- مشاركته عبر Google Drive.
- إعادة تسميته ثم مشاركته.
مشاركة جميع الملفات.
- حذف جميع المقاطع.
- حذف المقطع الحالي.
16. في نافذة التسجيل المخصص نجد الخيارات التالية.
- معرفة حالة التسجيل
- بدء تسجيل جديد أو إيقاف التسجيل الحالي.
- برمجة تسجيل معين ليتم بدؤه في وقت نحدده، كما يمكننا اختياراً تحديد المدة ليتم إيقافه تلقائياً. هنا نكتب الوقت او المدة بالساعات ثم الدقائق ولا حاجة لوضع النقطتين لأنها تكتب تلقائيا، وأثناء اكتمال الخانة الاولى ينتقل المؤشر تلقائيا للخانة الثانيَة.
- بدء تسجيل مخصص ليتم إيقافه تلقائيا حسب القيمة التي اخترناها.
17. عنوان شاشة إدارة التسجيلات يعرض العدد الإجمالي للملفات أو عدد نتائج البحث أو عدد العناصر المحددة.  عند الضغط عليه، يعرض حجم المجلد وعدد الملفات. وعند الضغط المطول عليه فإنه يذهب إلى نافذة تغيير المسار وهي تمكننا من عرض المسار الحالي كما تمكننا من تغييره، سواء بإدخال مسار جديد، أو اختيار مسار تم حفظه سابقاً..
18. تحت العنوان يوجد مربع البحث وهو يعمل بنفس الطريقة التي يعمل بها مربع البحث في الشاشة الرئيسية للإضافة، وله نفس الخصائص.
19. تحت مربع البحث يوجد زر تحديد الكل أو إلغاء التحديد عن الكل، وبجانبه يوجد زر عكس التحديد, ويوجد بجانبه زر الإجراءات من أجل مشاركة الملفات المحددة أو حذفها.
20. عناصر قائمة إدارة التسجيلات   تحتوي على مربعات الاختيار بحيث يمكننا تحديد كل عنصر على حدة، أو يمكننا التحديد المتعدد  من  وإلى  عبر الضغط المطول، الذي يمكن تنفيذه أكثر من مرة.
21. تحتوي شاشة الإعدادات على الاختيارات التالية:
الإعداد الأول: لاختيار مصدر التسجيل.
الإعداد الثاني: لاختيار معدل البث الخاص بالتسجيل.
الإعداد الثالث: لاختيار الترميز.
الإعداد الرابع: لاختيار عدد قنوات التسجيل.
الإعداد الخامس: لحفظ مسار جديد للتسجيلات، أو لاختيار مسار تم حفظه سابقاً.
الإعداد السادس: لتحديد الإجراء الافتراضي الذي يتم أثناء استدعاء الإضافة ما لم يكن هناك تسجيل.
الإعداد السابع: لتحديد الإجراء الذي يتم بعد إلغاء بدء التسجيل.
الإعداد الثامن: لتحديد الإجراء الذي يتم بعد إلغاء التسجيل الحالي؟
الإعداد التاسع: لتحديد الإجراء الذي يتم بعد إنهاء التسجيل الحالي.
- كما يوجد زر إضافي لعرض معلومات الحجم أثناء اختيار معدل البث، والترميز.
- العودة إلى قائمة التسجيلات.
الخلاصة:
هذه الإضافة تمكننا من التسجيل بأكثر من طريقة وبأكثر من جودة وذلك حسب الحالة.
كما تمكننا من معاينة التسجيلات وإعادة تسميتها ومشاركتها وحذفها.
ويمكننا استخدامها كمسجل أو كمشغل للملفات الصوتية.
أما بالنسبة لإدارة التسجيلات، فإن شاشة إدارة التسجيلات تمنحنا مرونة في التعامل مع التسجيلات وذلك عبر الدمج بين التحديد المتعدد والبحث.
وتوفر الإضافة سهولة في التنقل بين الخدمات المذكورة سابقاً.

]]
  for line in helpText:gmatch("[^\r\n]+") do
    print(line)
  end
end


function info()
  local helpText = [[
Bit Depth
32 kbps  = 0.24 MB/min  閳拷 14.4 MB/hour, for speeches
64 kbps  = 0.5  MB/min  閳拷 30.0 MB/hour, space saver
96 kbps  = 0.7  MB/min  閳拷 42.0 MB/hour
128 kbps = 1.0  MB/min  閳拷 60.0 MB/hour, similar to CD quality
160 kbps = 1.2  MB/min  閳拷 72.0 MB/hour
192 kbps = 1.5  MB/min  閳拷 90.0 MB/hour
256 kbps = 1.9  MB/min  閳拷 114.0 MB/hour
320 kbps = 2.4  MB/min  閳拷 144.0 MB/hour
Sampling Rate
8000 Hz Very low quality, suitable only for telephony; speech sounds rough and lacks detail.
16000 Hz Medium quality, commonly used in VoIP and speech recognition; clearer speech with better consonant clarity.
22050 Hz Decent quality for music and general audio; some high-frequency details may be lost.
32000 Hz Good compromise between quality and file size; used in broadcasting and video; better fidelity than 22.05 kHz.
44100 Hz CD-quality audio; excellent clarity and detail across the audible spectrum.
48000 Hz Professional audio and video standard; high fidelity and accurate synchronization with video.]]
  for line in helpText:gmatch("[^\r\n]+") do
    print(line)
  end
end

if isCurrentlyRecording() then
  toggleRecording()
 else
  _G[mainFunctionName]()
end